GNU bug report logs - #51404
Support system dark mode on Windows 10

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: Vince Salvino <salvino@HIDDEN>; Keywords: patch; dated Tue, 26 Oct 2021 06:58:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 12 Nov 2021 06:19:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 12 01:19:53 2021
Received: from localhost ([127.0.0.1]:43111 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mlPuj-0004Oc-8x
	for submit <at> debbugs.gnu.org; Fri, 12 Nov 2021 01:19:53 -0500
Received: from eggs.gnu.org ([209.51.188.92]:34572)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>)
 id 1mlPue-0004O2-3L; Fri, 12 Nov 2021 01:19:51 -0500
Received: from [2001:470:142:3::e] (port=33576 helo=fencepost.gnu.org)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mlPuY-0001om-OP; Fri, 12 Nov 2021 01:19:42 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=0PBZbzmonAKMntBtIFB81brghKlU32JAMBte4BR9rkE=; b=guusM14171Nu
 uI0IOJMXg1Y7OhRCuYvP4ic6T+hHewiOrxvd2Q6OEaQCVc0/azPQF15el9JSF//1z/SOi+2LJ/J9P
 B3YVDKNztHtfHCV1dHVFeop7m76cC+lf+f+hzrwiXwCNPNzLcpHhTGX9g/sJQ+mybWYCXDJW90mZM
 e9MaR5r8J0sBESCbwJs6lPXh5dOLhUN6L7oPNxugpR+RxoeIi1CUtR/j3cJkiZf1wpPzXDTsgxuYQ
 KIM0pmKRZsS6WhShv2SkkNY0OZGDmacFEwgfLWw4ngOJhdRvRWP82cJQu5Nsl8i3MspwFmq8KcnJb
 75EG1/dnl5jJNhknGk8rbw==;
Received: from [87.69.77.57] (port=2465 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mlPuY-0001Gn-BZ; Fri, 12 Nov 2021 01:19:42 -0500
Date: Fri, 12 Nov 2021 08:19:22 +0200
Message-Id: <83k0hdzyj9.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87czn63wot.fsf@HIDDEN> (message from Lars Ingebrigtsen on Fri, 
 12 Nov 2021 04:00:18 +0100)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN> <83a6iqpzrv.fsf@HIDDEN>
 <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN>
 <83k0huo1iy.fsf@HIDDEN> <87wnlf8d9y.fsf@HIDDEN>
 <83wnlf166j.fsf@HIDDEN> <87wnle6g8o.fsf@HIDDEN>
 <83ee7m20iz.fsf@HIDDEN> <87czn63wot.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: salvino@HIDDEN, 51404 <at> debbugs.gnu.org, 47291 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: salvino@HIDDEN,  51404 <at> debbugs.gnu.org,  47291 <at> debbugs.gnu.org
> Date: Fri, 12 Nov 2021 04:00:18 +0100
> 
> > Maybe.  But some expert (which is not me) will have to explain what to
> > do when we receive these messages, or submit patches for that.
> 
> On the Linux side, we convert the messages to input events and then
> react to that event from special-event-map, which seems like a
> reasonable structure.

I mean how to tell what the message wants us to do, i.e. which parts
of the UI to change and in what way.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 12 Nov 2021 03:00:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 11 22:00:43 2021
Received: from localhost ([127.0.0.1]:42746 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mlMny-00074D-Tw
	for submit <at> debbugs.gnu.org; Thu, 11 Nov 2021 22:00:43 -0500
Received: from quimby.gnus.org ([95.216.78.240]:60178)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1mlMnj-00073W-Oc; Thu, 11 Nov 2021 22:00:41 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=PTYBUmw8Z7FniTTzeJfyBphpDLoyRK73Gz5KKT0o0qk=; b=iw8PJPNc7aBLoGBdbBqw/QVtS1
 AumCPALCjNtbQrCP7sXI+LWQfoLZ5xNH/tB6/Ot35TZ01NTV4eJYYYFodHh01QKhq4KGn13V/NsN7
 9KCCWvMIpCQAoAbVqENWnG+C6I3Cb9Mr+2EV1a4/ctV12x9qm4iM4rSoJBNesVjUicHY=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1mlMna-0003N7-Qx; Fri, 12 Nov 2021 04:00:21 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN> <83a6iqpzrv.fsf@HIDDEN>
 <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN>
 <83k0huo1iy.fsf@HIDDEN> <87wnlf8d9y.fsf@HIDDEN>
 <83wnlf166j.fsf@HIDDEN> <87wnle6g8o.fsf@HIDDEN>
 <83ee7m20iz.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwAgMAAAAqbBEUAAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAADFBMVEXf399/foAkJCb/
 //8aMSjyAAAAAWJLR0QDEQxM8gAAAAd0SU1FB+ULDAIxCQtexUAAAAGFSURBVCjPhZLNboJAFIUP
 BIiykkRMOyvTaNLwFEOjXWMiprLqwiZ1noJ20TUuNCkr2ohh7lP2zmDTZWc13z2XOfcH4O+M4KzS
 aOzH4zW8DL6XRojyKDOag+UCqQf4BQGrSEo4G6KcAxyMFR3z0uYVpNexqhu+k2YZ8zxeQyJzNhpI
 sVpyPhKqK1z2Fy35E6JTh8vnyxMLLrWHOQ5EHZcTqBIusg86szJUC6eWMyQHhoHaK8IUQ+PptaKd
 yGnfxFjevamSJFsCAkrrgCounz1vEv0aUGfuEIOwGrmkHiqGrX/LkaOyPrIQQGgrADb0KCEaZUHV
 7yUmTULcCPank0bIQEb55gT3CgkdMziNsMAzyEeD54C4IhAbJJpteyCZkOm+tKCFhcpC5SvJ0PRp
 CA2cLQDBmR/QV8XtemgL84xROtv6Hpgx7Mzy/C33H1Ar7bR2DL6qS2Eg4MX4okBid5chGwZLhBZ2
 rKawSp7zapyvGWI7SLGAJ8cmKeZ53//+PixlI/xzfgA4zIj9xqxzCwAAACV0RVh0ZGF0ZTpjcmVh
 dGUAMjAyMS0xMS0xMlQwMjo0OTowOSswMDowMBA//9wAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjEt
 MTEtMTJUMDI6NDk6MDkrMDA6MDBhYkdgAAAAAElFTkSuQmCC
X-Now-Playing: Sonic Youth's _Goo_: "Dirty Boots"
Date: Fri, 12 Nov 2021 04:00:18 +0100
In-Reply-To: <83ee7m20iz.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 11 Nov
 2021 17:08:04 +0200")
Message-ID: <87czn63wot.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > If that's what people
 want, sure. I'd expect them to want Emacs to go > to dark background on all
 frames. Possibly -- there should probably be a user option, I guess. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 51404
Cc: salvino@HIDDEN, 51404 <at> debbugs.gnu.org, 47291 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

> If that's what people want, sure.  I'd expect them to want Emacs to go
> to dark background on all frames.

Possibly -- there should probably be a user option, I guess.

> Maybe.  But some expert (which is not me) will have to explain what to
> do when we receive these messages, or submit patches for that.

On the Linux side, we convert the messages to input events and then
react to that event from special-event-map, which seems like a
reasonable structure.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 11 Nov 2021 15:08:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 11 10:08:15 2021
Received: from localhost ([127.0.0.1]:41937 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mlBgU-0006pI-QQ
	for submit <at> debbugs.gnu.org; Thu, 11 Nov 2021 10:08:15 -0500
Received: from eggs.gnu.org ([209.51.188.92]:57488)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>)
 id 1mlBgS-0006oy-W3; Thu, 11 Nov 2021 10:08:13 -0500
Received: from [2001:470:142:3::e] (port=56760 helo=fencepost.gnu.org)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mlBgM-0007VH-Cp; Thu, 11 Nov 2021 10:08:07 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=Bi9DzzxszVB6DzQl2QhPBI+fVguYZSfHEM/WjOAL138=; b=VCj1P6sEiy5T
 YSYbXFZZM33R9nuqF21XCZPsdGozP9+sp2qHoCZWIIdaHENb+gjoXWZ6ZKIAfVTy9Isxauleg2R5F
 qmBsz+JmJnvV2CsG1fnMvwIiiGvl+pIjnoF8cLeWZbbKL3EtaztypoBBNnJ6TfD94tkbxljCoWZIJ
 wE1poeRluPE1Zv40pC6GkD6hOEcZXn1FeONMCcDXa3j0DKNpkddWzROSxdrS/aq4d4H6HUAl0rdwE
 1QbWyApMX1IVZ+Ej1EyDibuGStkZsikGEXL8vL12uCdFMNt+LNIeo8TRM0UnCMPN2k42rhV+4TSmd
 FYAIqgGqJKqBd2yHQQQCJg==;
Received: from [87.69.77.57] (port=2143 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mlBgL-00071O-RT; Thu, 11 Nov 2021 10:08:06 -0500
Date: Thu, 11 Nov 2021 17:08:04 +0200
Message-Id: <83ee7m20iz.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87wnle6g8o.fsf@HIDDEN> (message from Lars Ingebrigtsen on Thu, 
 11 Nov 2021 13:15:03 +0100)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN> <83a6iqpzrv.fsf@HIDDEN>
 <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN>
 <83k0huo1iy.fsf@HIDDEN> <87wnlf8d9y.fsf@HIDDEN>
 <83wnlf166j.fsf@HIDDEN> <87wnle6g8o.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: salvino@HIDDEN, 51404 <at> debbugs.gnu.org, 47291 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: salvino@HIDDEN,  51404 <at> debbugs.gnu.org,  47291 <at> debbugs.gnu.org
> Date: Thu, 11 Nov 2021 13:15:03 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > I'm not sure unification is possible here, because the functionality
> > is quite different, AFAICT.  At least for the functionality in this
> > bug report, we cannot apply the system theme to an existing frame, we
> > can only apply it at frame creation time.  So having a handler for
> > such changes will be able to affect only the frames created after the
> > change.  Or at least that is my understanding; the code definitely
> > applies the dark/light theme as part of creating a frame.
> 
> Gtk Emacs doesn't respond to dark mode either -- so we have the
> opportunity to decide how to handle these things across the board.
> Perhaps in Gtk Emacs, dynamic-setting-handle-config-changed-event should
> also just set something that will make the next frame creation use
> different colours?

If that's what people want, sure.  I'd expect them to want Emacs to go
to dark background on all frames.

> > Also, having a dynamic thing that tracks changes in these settings
> > would on Windows mean listening and processing a special window-system
> > message, which seems to be WM_THEMECHANGED or maybe WM_SETTINGCHANGE.
> > But that's not what the code installed in this bug report does.
> >
> > So the functionality seems similar, but the details differ.
> 
> But perhaps Windows should be listening to those events, too?

Maybe.  But some expert (which is not me) will have to explain what to
do when we receive these messages, or submit patches for that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 11 Nov 2021 12:15:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 11 07:15:32 2021
Received: from localhost ([127.0.0.1]:40344 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ml8zM-0007ki-15
	for submit <at> debbugs.gnu.org; Thu, 11 Nov 2021 07:15:32 -0500
Received: from quimby.gnus.org ([95.216.78.240]:53624)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1ml8z3-0007jw-ID; Thu, 11 Nov 2021 07:15:29 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=GP54OdRhE5PVChyqcqHU57Gn/RE/mHzenueTptACiqk=; b=oIX1s7mLR03+ZXsZL5JhzfPlRj
 W8UKQwH/Bxek6BHId76cGvTs9MG8HQuTanbTqaFunrSCTyYLm1iiKBGCwgwF8FyTxNWW+WbK3KN8P
 FpadLexHISXNBkdEWhyUT3sWmcCufuNwWxMZ9/S+b4S1ihMUAsTyR2ePceHiFxSlFtZM=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1ml8yu-0005Xq-7E; Thu, 11 Nov 2021 13:15:07 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN> <83a6iqpzrv.fsf@HIDDEN>
 <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN>
 <83k0huo1iy.fsf@HIDDEN> <87wnlf8d9y.fsf@HIDDEN>
 <83wnlf166j.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEWDe3BYU0yll4K9
 oXnauo3gvo7gwZT///+NHmO0AAAAAWJLR0QHFmGI6wAAAAd0SU1FB+ULCwwJAYVT5DoAAAG3SURB
 VDjLdZNNbqQwEIXd0WQPMxdApJV1NEazjgabA6SrvI4S7PsfYV65yuBoOg+1G/zh+sddxsFBF9fr
 Mo5uVGB6mEWTvDiOPqjWZfWLX+yhA00ciO+CWErJ94Cw9A2476MHEe6aFZKVBCDAyBCWgr/EEXc3
 M4VbpRCecjbAQZ4D4YrIAuF+GrBXQyo7fqVwc67msZoOH0DRDpYsPzG16o6uhRE5fMgJDYoJoKSS
 iaRYCmJAEsFegDY1JTY0XckR9uVSEGEYLMIt58Qpa1TNBJmrCD+1iCfQm5Bh9DwRa+aBu7LX5xps
 /toP2U+v0+Oru/4HYlj9n7/TY64Z9uDlYXIf8/S87j5sEsZqCYbg5zeAp3fnniP62wDvbnqar9f9
 uiy18c0U0W/v/fzjw/38tZuPoYKIRqF1exfVoPWz9qacKZ6AD2G37ImogRhqYdE6VJq2OtTD2SCZ
 AjFHp3O1XyzxA+h+THXumPpwq9c21tJPBTUcOioLk3Q7ANcia7Ig5wk5j0+A61TVuRq00dBWTu0C
 zFAd86ZbAzYEGKkOBJsdU52LdqLbly+Vws3K/kUba8/vaBjHf0usLVcfdy2oAAAAJXRFWHRkYXRl
 OmNyZWF0ZQAyMDIxLTExLTExVDEyOjA5OjAwKzAwOjAwgbmcCQAAACV0RVh0ZGF0ZTptb2RpZnkA
 MjAyMS0xMS0xMVQxMjowOTowMCswMDowMPDkJLUAAAAASUVORK5CYII=
X-Now-Playing: Hype Williams's _Junt-Deez Ruins You See_: "Infinity"
Date: Thu, 11 Nov 2021 13:15:03 +0100
In-Reply-To: <83wnlf166j.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 11 Nov
 2021 09:51:16 +0200")
Message-ID: <87wnle6g8o.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > I'm not sure
 unification
 is possible here, because the functionality > is quite different, AFAICT.
 At least for the functionality in this > bug report, we cannot apply the
 system theme to an existin [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 51404
Cc: salvino@HIDDEN, 51404 <at> debbugs.gnu.org, 47291 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

> I'm not sure unification is possible here, because the functionality
> is quite different, AFAICT.  At least for the functionality in this
> bug report, we cannot apply the system theme to an existing frame, we
> can only apply it at frame creation time.  So having a handler for
> such changes will be able to affect only the frames created after the
> change.  Or at least that is my understanding; the code definitely
> applies the dark/light theme as part of creating a frame.

Gtk Emacs doesn't respond to dark mode either -- so we have the
opportunity to decide how to handle these things across the board.
Perhaps in Gtk Emacs, dynamic-setting-handle-config-changed-event should
also just set something that will make the next frame creation use
different colours?

> Also, having a dynamic thing that tracks changes in these settings
> would on Windows mean listening and processing a special window-system
> message, which seems to be WM_THEMECHANGED or maybe WM_SETTINGCHANGE.
> But that's not what the code installed in this bug report does.
>
> So the functionality seems similar, but the details differ.

But perhaps Windows should be listening to those events, too?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 11 Nov 2021 07:51:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 11 02:51:29 2021
Received: from localhost ([127.0.0.1]:40054 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ml4rp-0000KI-1G
	for submit <at> debbugs.gnu.org; Thu, 11 Nov 2021 02:51:29 -0500
Received: from eggs.gnu.org ([209.51.188.92]:37516)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>)
 id 1ml4rl-0000Jw-At; Thu, 11 Nov 2021 02:51:25 -0500
Received: from [2001:470:142:3::e] (port=44676 helo=fencepost.gnu.org)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1ml4rf-0000lW-Pb; Thu, 11 Nov 2021 02:51:19 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=gJyEuzZTmsxqRlWo3gN/CCJe1XXhDEBWJtg+Sn4tRYo=; b=meeiYWvGJ9z9
 tLy06PmYvrnnqBSv6NoLkmUY8vo+7rLe+UjSxz4IOsNWBHvgYPoA5qKKgKOMZrhVE5U84uhiouQ0A
 ApxGNBqUvpZOSVB2U/6mWjSoJTWqGNvExKjh+etQoJO409w6ND7cIB/DwYRU8ocJyEM8Yi9dwXXUu
 Usss4ut7I6P03rdo6TEaYAsBXKhcWKcT0zyH7+K7MpK1CRy0hiqK6EkInOpiHnV2NumQRQ7n5no8b
 Kabmho6p0u8Gvfni5cXy+Yt2+/+FbHe92n8Wg4YgKmMsG+LtWL72YqgkxKsGA2y4L70A2vDK1I5X+
 fyV8+CCqBWfxlKTTIyA4EQ==;
Received: from [87.69.77.57] (port=3193 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1ml4rf-0008OV-BL; Thu, 11 Nov 2021 02:51:19 -0500
Date: Thu, 11 Nov 2021 09:51:16 +0200
Message-Id: <83wnlf166j.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87wnlf8d9y.fsf@HIDDEN> (message from Lars Ingebrigtsen on Thu, 
 11 Nov 2021 06:36:09 +0100)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN> <83a6iqpzrv.fsf@HIDDEN>
 <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN>
 <83k0huo1iy.fsf@HIDDEN> <87wnlf8d9y.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: salvino@HIDDEN, 51404 <at> debbugs.gnu.org, 47291 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Vince Salvino <salvino@HIDDEN>,  51404 <at> debbugs.gnu.org,
>  47291 <at> debbugs.gnu.org
> Date: Thu, 11 Nov 2021 06:36:09 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > I'm not sure I understand why 'light' necessarily means the old
> > behavior: we didn't set any theme before this change, we just used the
> > Windows default.  So maybe there should be 4 values:
> >
> >   nil: never follow the system theme (use Windows default)
> >   t: always follow the system theme
> >   light: force light theme (currently the same as nil)
> >   dark: force dark theme.
> 
> For a similar bug report, see bug#47291.  And we really should support
> this on GNU/Linux, too, so having three different methods to support
> this seems sub-optimal.

I'm not sure unification is possible here, because the functionality
is quite different, AFAICT.  At least for the functionality in this
bug report, we cannot apply the system theme to an existing frame, we
can only apply it at frame creation time.  So having a handler for
such changes will be able to affect only the frames created after the
change.  Or at least that is my understanding; the code definitely
applies the dark/light theme as part of creating a frame.

Also, having a dynamic thing that tracks changes in these settings
would on Windows mean listening and processing a special window-system
message, which seems to be WM_THEMECHANGED or maybe WM_SETTINGCHANGE.
But that's not what the code installed in this bug report does.

So the functionality seems similar, but the details differ.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 11 Nov 2021 05:36:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 11 00:36:24 2021
Received: from localhost ([127.0.0.1]:39877 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ml2l5-0004Mv-Ox
	for submit <at> debbugs.gnu.org; Thu, 11 Nov 2021 00:36:24 -0500
Received: from quimby.gnus.org ([95.216.78.240]:50206)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1ml2l2-0004MY-NG; Thu, 11 Nov 2021 00:36:21 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=mzjntn0LwIWCNzk4cYH++LOQharC2AAiBkT2W6+tp1Q=; b=u5fp25xI3tKkJYi73d3rPITLoQ
 iRWtHX3oFTWw89jHamnfZcbR3SfW24UGWaOt4sjIujP7J1mAzPdikNZeaLNLZinaHZ1lbVkAumSUM
 RONkkXvTuOCOmjAa9lbVn5EDTtVCWXJ/Lf+TSw1qHZeDPj26PQww5oH9OJN7Wn+dky1Q=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1ml2kt-0002j9-NN; Thu, 11 Nov 2021 06:36:14 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN> <83a6iqpzrv.fsf@HIDDEN>
 <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN>
 <83k0huo1iy.fsf@HIDDEN>
X-Now-Playing: King Crimson's _The Complete 1969 Recordings (26): BBC
 Sessions_: "Trees"
Date: Thu, 11 Nov 2021 06:36:09 +0100
In-Reply-To: <83k0huo1iy.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 30 Oct
 2021 20:39:17 +0300")
Message-ID: <87wnlf8d9y.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > I'm not sure I
 understand
 why 'light' necessarily means the old > behavior: we didn't set any theme
 before this change, we just used the > Windows default. So maybe there should
 be 4 values: > > nil [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: Vince Salvino <salvino@HIDDEN>, 51404 <at> debbugs.gnu.org,
 47291 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

> I'm not sure I understand why 'light' necessarily means the old
> behavior: we didn't set any theme before this change, we just used the
> Windows default.  So maybe there should be 4 values:
>
>   nil: never follow the system theme (use Windows default)
>   t: always follow the system theme
>   light: force light theme (currently the same as nil)
>   dark: force dark theme.

For a similar bug report, see bug#47291.  And we really should support
this on GNU/Linux, too, so having three different methods to support
this seems sub-optimal.

dynamic-setting.el seems like the most likely place to centralise all
this, I think?  I've had a look at what happens when you change the
theme in Gnome, and dynamic-setting-handle-config-changed-event gets
called with an

 (config-changed-event theme-name ":1")

event.  (But not what the event name is -- anybody know how to get at
that?)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 30 Oct 2021 17:39:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 30 13:39:39 2021
Received: from localhost ([127.0.0.1]:58437 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mgsKR-0005NP-EZ
	for submit <at> debbugs.gnu.org; Sat, 30 Oct 2021 13:39:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:35770)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mgsKP-0005NA-P6
 for 51404 <at> debbugs.gnu.org; Sat, 30 Oct 2021 13:39:38 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58976)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mgsKI-0007xt-LF; Sat, 30 Oct 2021 13:39:31 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=MlGH5S5MW70Bd7hSYQ89LC0wpbEDx9vZeEZbgQkFMwQ=; b=ja+NSrbjYRh2KEDDFQk+
 oasoC1t77MpZfkEJvMAAKReB9mcCbFAir4/9bN3/zQchW0lr5nFq8DGDfvTPSUSf0PsGEeXTT5ExC
 +Yn7Ywm63KoFi6MiBZw+toYv0/On1d/Q+5PL2mm0hZIbUJ5oD0qEwaTnmPTKtCaVyMo5jg6F6uAbW
 REGWWy1Nc0x2K9exfLtALCK27yBmy637r/5KRxRLilWyySwUjUdtLvZFSX69REYRUvi4Q4MxQzogO
 LCyhQqfMH59T4xsEbZiR2xQpiXBXgx4AxKTC6pJjn5ovAYrbgFPgtq1B1M+kdOiWhS2GlqTVz0Vil
 kbWPH5TKhtGHzQ==;
Received: from [87.69.77.57] (port=3561 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mgsKH-0005Z1-Ni; Sat, 30 Oct 2021 13:39:30 -0400
Date: Sat, 30 Oct 2021 20:39:17 +0300
Message-Id: <83k0huo1iy.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Vince Salvino <salvino@HIDDEN>
In-Reply-To: <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN> (message
 from Vince Salvino on Sat, 30 Oct 2021 17:13:13 +0000)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN> <83a6iqpzrv.fsf@HIDDEN>
 <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: 51404 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Vince Salvino <salvino@HIDDEN>
> CC: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
> Date: Sat, 30 Oct 2021 17:13:13 +0000
> 
>  > define a variable exposed to Lisp using DEFVAR_BOOL; let's call it w32-follow-system-theme
> 
> My thought would be to give the user a bit more control. Rather than saying to follow system theme or not, perhaps they could choose from 3 values: follow theme, light, or dark, e.g.:
> 
> w32-system-theme:
> * nil: follow system theme (default)
> * light: force light mode (the old behavior)
> * dark: force dark mode

I'm not sure I understand why 'light' necessarily means the old
behavior: we didn't set any theme before this change, we just used the
Windows default.  So maybe there should be 4 values:

  nil: never follow the system theme (use Windows default)
  t: always follow the system theme
  light: force light theme (currently the same as nil)
  dark: force dark theme.

> Second, could you provide an existing value from early-init that I
> could follow as an example?

early-init is a file, called literally "early-init.el".  If you have
such a file in your ~/.emacs.d/ directory, Emacs will load it early on
during the startup.

> (I never knew early init was a thing, so I am going to research this - it will probably make my personal init customization a lot better too!)

The recommendation is to move to early-init.el only stuff that cannot
work in the normal init file.  That's because early-init is processed
when some of the infrastructure is not yet set up, so things could
fail there that will work correctly in the init file.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 30 Oct 2021 17:13:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 30 13:13:23 2021
Received: from localhost ([127.0.0.1]:58369 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mgrv1-0004ae-KN
	for submit <at> debbugs.gnu.org; Sat, 30 Oct 2021 13:13:23 -0400
Received: from mail-co1nam11on2080.outbound.protection.outlook.com
 ([40.107.220.80]:3296 helo=NAM11-CO1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <salvino@HIDDEN>) id 1mgrv0-0004aQ-5Y
 for 51404 <at> debbugs.gnu.org; Sat, 30 Oct 2021 13:13:22 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=ZcmcTEBOMgNhativsPU2dkeUzg0sGXGpzjLu0w/1qpmBtE3GlZOcmP8sN60x5UHN0enauaCT9uYyu2ctLGIbLlFP5jqg6VSaHBz4wUlzConC6EChJBqhUE6DUIRiy5t7ln3j5fdmBSwa7r77mzd8QzgYOLDMnXJFSEy94zB9tM17xrSbeOF38FJIPDxpGSV1+4jr8r0zg84y13mf03rO1GU9yCtAnRBDvwy0LdNJ9AH3CUhH9gwVPh1LJPZJct6qqXgdDrDQzlnJ8NjYUXCxBIcUCFKD930HA/dADPPvJCPMRjLlHHxoCud2KXAxjamqZbfyX1Ry5d1XPgiLeVW3NQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=yaHnjaBZWGQz+pj32aRrz29jkN1m1oeDQQyeuqy5ybI=;
 b=BYnDfL3XCbnfCgg8Q6kUMvL4J+K6ATdXuIh7LSS8IjJ8lSMxKco+NUT4vEjNU7v2ixTPMVxmyOQ9Jsiyp/JairFgF8FLswLnc+sTMyWLxrbxELxUiDbzD1DAFi886WI0Hix2Nnd17n8nh5js1g0x+wiQTrz0hwf+6uLI/JOMbTBrbg5SEaTe5vK1ffdP2oatZkPoFDEpsbzRDDKrUzeFv+C2srp8vVBHBASCzxp2KG0pwmNhn5SzEuV26ihlOE5x4nicbuNuvVEg66gO5gX004foPC6hZeSEAAftPP7Uaige5y/N2ZWMn8bwF6vFcj7UINwnTUeSlbRypT8zobBNSQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=coderedcorp.com; dmarc=pass action=none
 header.from=coderedcorp.com; dkim=pass header.d=coderedcorp.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=coderedcorp.com;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=yaHnjaBZWGQz+pj32aRrz29jkN1m1oeDQQyeuqy5ybI=;
 b=D6Wmdj9ZrRBX/q3uBprsASH8stMtvG3DnqtL+m+y9XaCYqXsx1z2h36fee0sY28bYTLFOs+LjaxX7VnUxqBBJXYqU0NK0aL/tXbSY77JwOcheqzL5aI8V6Ikgfq1PN7m7U+ugfJ0fTH0aXJbD3GnUalqHyMN5tZert8GlzLkxBw=
Received: from CH2PR12MB4231.namprd12.prod.outlook.com (2603:10b6:610:7d::24)
 by CH2PR12MB3733.namprd12.prod.outlook.com (2603:10b6:610:15::14)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4649.15; Sat, 30 Oct
 2021 17:13:13 +0000
Received: from CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b]) by CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b%5]) with mapi id 15.20.4649.018; Sat, 30 Oct 2021
 17:13:13 +0000
From: Vince Salvino <salvino@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#51404: Support system dark mode on Windows 10
Thread-Topic: bug#51404: Support system dark mode on Windows 10
Thread-Index: AdfKJC1fFkosmLKeRpu5RIGxKoA2egATeE0VAAVMuSAAARwnVAACGfogADmStWAAFE6XhABrhkosAA3s1gA=
Date: Sat, 30 Oct 2021 17:13:13 +0000
Message-ID: <ddm9cg097co1e4d11e8bh6c6.1635613989653@HIDDEN>
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN> <83a6iqpzrv.fsf@HIDDEN>
In-Reply-To: <83a6iqpzrv.fsf@HIDDEN>
Accept-Language: en-US
Content-Language: en-US
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
authentication-results: gnu.org; dkim=none (message not signed)
 header.d=none;gnu.org; dmarc=none action=none header.from=coderedcorp.com;
x-ms-publictraffictype: Email
x-ms-office365-filtering-correlation-id: 1c30ff36-555b-4dc2-6ce9-08d99bc88e78
x-ms-traffictypediagnostic: CH2PR12MB3733:
x-microsoft-antispam-prvs: <CH2PR12MB37337D79823CEB5BF10E0998A5889@HIDDEN>
x-ms-oob-tlc-oobclassifiers: OLM:8273;
x-ms-exchange-senderadcheck: 1
x-ms-exchange-antispam-relay: 0
x-microsoft-antispam: BCL:0;
x-microsoft-antispam-message-info: LpBOfgj9nHVoTie/1LdtkZR+d026vuCKfT7/nVjX1+s6lNFo8j3MYib0RXwIee8gNACwFc7z9c5TSqTF1ahLG7B9l++fqARm0+aN1Kp+u12r5elqflFeOSuC8t3aBwyCiOk5VW0wsa8XkbLpvXI0qQ32JHKS7h5dqHYPIl2OE3gjNE8TZ5Dikb1pdrDt3F+Rg4NQtZv1sebzt7h1pkozTqJ5WdqI+iyXW82c1Kd2xnechu8YdeniKDPGxizSKIEv28opQbRsNIZG2w1AZz7zxZ9Nl9V6+EGCOVECdyo9jjUrbz+V0LMhIPIxWnobN/RII2quYwla68P+imf4Ev2O9ZRpo/xqzvOz3g0l0xVtv4xjoFfn7iZFDCKGYJeAGRW2G7FtsX8YRaxmj526N5H6uxziiCO+v9LdrrL3CuyUDYnjwKpMl+enmiRY1y4FvJlLjrBGaGSMPR64npuDW53i6Z+A0GTx44890dR+lJKuI7UYo3uKKfRGzXXxtoo7anj2CvxhBJjYcPY/0+VPyH1MPk3fs8+TNSf/7E3gGigpfbPyNQc9JERN36Rg9TsQIxuO88MUHEYhs0H3g6ObBN6HE7BxMtnm40S20+V2fFSBmAKmFJ6TUADO4vQgIp9CJx0XKCmrupmALubLkPG3Hfiw+Ab/6cMhDfmWvtkFWG/0sBJBso39Br/Nsy6wDlSg7fV5WHzeotzXcHOWRsF2nMICsw==
x-forefront-antispam-report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:CH2PR12MB4231.namprd12.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(366004)(39830400003)(136003)(396003)(376002)(346002)(6512007)(8936002)(71200400001)(36756003)(2616005)(4326008)(6506007)(8676002)(6486002)(86362001)(4744005)(64756008)(38070700005)(508600001)(2906002)(5660300002)(38100700002)(66946007)(122000001)(316002)(6916009)(66446008)(76116006)(26005)(66476007)(186003)(66556008);
 DIR:OUT; SFP:1101; 
x-ms-exchange-antispam-messagedata-chunkcount: 1
x-ms-exchange-antispam-messagedata-0: =?utf-8?B?QS9JZjJadXFSM3NXVTN3YmJKNG1yY29pSXlWT29Kbnc3QnlqOWo3WUluMVU0?=
 =?utf-8?B?OTJBYlB0Zlpub29xb1V4YitRQkUzQ2ZlUExlb0J5K0xVV0tpejBPaU9YK2I0?=
 =?utf-8?B?bXNrYW5OYVNTSk91anphS1YrVFJ4S2J6THE4UW5kRkFXN1VjSTJzL2FKcGNx?=
 =?utf-8?B?dDhsUi9yVEdUa21FZDEwNDNOc2RIeEFBS205MEhKRFFHT0FaSm5GS0RGQ1hH?=
 =?utf-8?B?SlRUUTJQdE5IeU5MdEsvcUM3OER6d0U4OVVrbHN6SzRCTmxTNE5ZcFgvSmFk?=
 =?utf-8?B?dXZMNHVRZjVKWW96YjQwNzFNUVJseDNSS0FiTVpqdk5DbHBzRjFzV2lFeGZG?=
 =?utf-8?B?WlNGL0J3TEZHdW5uNENwMmpTRDBkYXQ2MTRIRmZkU0tEN05COU8vbFNnM2F1?=
 =?utf-8?B?UjN0M1p4RVVMTUtpaFFIQkJna2RiejJHTHhKcXpFQitPV2pac0cramNqaGxt?=
 =?utf-8?B?LzB6SlJ2Q0ZWdG9jdStsVW16VHVzZVJoQnljMmZBWWlIblo3R3QyV2psOUZa?=
 =?utf-8?B?dW5DTVVYYW9ROTZuRzk5dGhWVjMxTXVJRytBVHYwSldzQnpMdWFUTzBRc0NB?=
 =?utf-8?B?K3I1TDhmdE5GaHBwOWhkRUFYOVZaeEo1cUt6b29FNUZ6Q21UdWwraVpiTzZv?=
 =?utf-8?B?N2VLckF0Z3pYa3R0OFJQaWRPZEdoRmpwY0lDWmpaTXZhMHRxZFEybWV2Z05K?=
 =?utf-8?B?cDJsU0NSZThrbFk2b3pCY1gzc29HNDRVWkUzYkRTRzZJSDdkRmkwOHZ4TGVx?=
 =?utf-8?B?ZWx4SWRjK2JFYlo0dzRYZ2FJUnhZWTcyRHc4VGwwN3hGbFZid01neE53eXp0?=
 =?utf-8?B?anFOdmlMK1pJK3RoSXF6czlEbjB4bExCMUtkTVB4Y1N1VU1KMnpMaHdLanY1?=
 =?utf-8?B?cDAxd21vT29sQ2VLMXh2MVF3VHV3eS9BdkxIN2dEMDNZbHZEQUNuM1U0V3VM?=
 =?utf-8?B?YStleVRRSHE2SjZkaG94Nm81dWFDWUQvU1BQNHJlRGtNUDFBZnErWEVBMTZw?=
 =?utf-8?B?NWIvSXEvK2s5Z25HbXZ0bTI1ejk5Mkt1OXZzNEtJUk1sVWxQbXNDdHFiUTJN?=
 =?utf-8?B?dnJ0SnRuNGt4QWV4N0luVXNqTi82T3RXc3NvK25RUi9XNXZzalA1L0lpYm9Z?=
 =?utf-8?B?OHFlRHNnRC91YzVha3FyWDN5V1djZWN0S1VRcFpScWhOZ3BHTU9YbWpoS0Zj?=
 =?utf-8?B?Yk15UUo3SDk4UzZVQU5VeXRhSDZRR29hNDlKeUFqNXBEQVdMalpTRUw5cmRX?=
 =?utf-8?B?clpvZGhNbC9FMG5ieVRJSnd2OWVxd3lKVis0bTRQek80N0htcFhQY2tHbXpY?=
 =?utf-8?B?T3pzVURNWWs4akdka3lRejFyOWJIWjZpVmp3dGRIcmx4Q1U1TW50SXMxTjNp?=
 =?utf-8?B?dGhRbXRTVktNajdQVExWZFF2bmJWUlhYRTlZT09abkVxTUpoeXM4YjRPa1RD?=
 =?utf-8?B?WHNOL3ppRUNTekJtc0E1dndmN3hiZmpkQXVhWWQ5dmlyUVRjZEJBWG1zZEhG?=
 =?utf-8?B?Z0lYbnNzaDdFVXdyMnExWFNmMUpaY2dvbFU4YTVSZmhSSk9vVFFMUUZmR2tJ?=
 =?utf-8?B?V3ZFU0hRT0h6bGhEc3JqaUpybjZ4M2JVR01MYVBDYUx1TG9Rb0pKZTg2T1U4?=
 =?utf-8?B?NW1kRmVnV200anI2V1haMTdzVUVwYTNwNUpyVW04STNlZjUvSjl2WjZjVkVo?=
 =?utf-8?B?Nkd6QWk4amFGRnMrTU5VNUxEbC9ITkl2TlJoTlEzZFd4MC8xUEROaFFPYjli?=
 =?utf-8?B?VmZFSHVQMDB3b3B2RER5L1EyNVhSNzY5NDdnRUdJMHRIWGMxWTRkZHdIWUtz?=
 =?utf-8?B?NU50UnNGNzB4NUlTWE9kMk5rMXYvYVV2OSt2ajRNV2ZIdXpVc3YveXdwVndX?=
 =?utf-8?B?eVppbzMwanMyYll1WnoyZ2IvSmp2ekJxSFA0YitYWHNGZFZVenlFN1UvSm1S?=
 =?utf-8?B?RG0xTlpuM3AwMGVrQzZmY2pWMklldyt4SFhOcno1Z1VKdXNzK0t5YytocHEz?=
 =?utf-8?B?c3FDZENQNVhUcWVxM1R1VVZkd1JNeHZCL0NZVkhpNXJPODJZeVdTWVJFOGNh?=
 =?utf-8?B?aFVpbFlRTHhOMlhLZHAyUS8yMlV3VXBTWGIyQWxZNkRJcy9UTnoyd2lpWXJ5?=
 =?utf-8?B?b2g2QXd3ekVSY0JqN1ZaS0FabEV4STRxM3M0MVZPR1pxVjh5c1ZJa1c1bHpv?=
 =?utf-8?Q?pjRsN5X4X15GutZGWhgcNIc=3D?=
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: base64
MIME-Version: 1.0
X-OriginatorOrg: coderedcorp.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-AuthSource: CH2PR12MB4231.namprd12.prod.outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 1c30ff36-555b-4dc2-6ce9-08d99bc88e78
X-MS-Exchange-CrossTenant-originalarrivaltime: 30 Oct 2021 17:13:13.3765 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Hosted
X-MS-Exchange-CrossTenant-id: 9c94adb1-2ce8-484f-be82-c9b5127d4cb1
X-MS-Exchange-CrossTenant-mailboxtype: HOSTED
X-MS-Exchange-CrossTenant-userprincipalname: owZJ62vf/pt0h4MKmjiWWd/8Y2XrVDYD27ztuDCKU4JVT9JYMuqsUEtoqh0VxET3Xnzc8WbjdqntlMKDRlysVA==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: CH2PR12MB3733
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51404
Cc: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

wqA+IGRlZmluZSBhIHZhcmlhYmxlIGV4cG9zZWQgdG8gTGlzcCB1c2luZyBERUZWQVJfQk9PTDsg
bGV0J3MgY2FsbCBpdMKgdzMyLWZvbGxvdy1zeXN0ZW0tdGhlbWUKCk15IHRob3VnaHQgd291bGQg
YmUgdG8gZ2l2ZSB0aGUgdXNlciBhIGJpdCBtb3JlIGNvbnRyb2wuIFJhdGhlciB0aGFuIHNheWlu
ZyB0byBmb2xsb3cgc3lzdGVtIHRoZW1lIG9yIG5vdCwgcGVyaGFwcyB0aGV5IGNvdWxkIGNob29z
ZSBmcm9tIDMgdmFsdWVzOiBmb2xsb3cgdGhlbWUsIGxpZ2h0LCBvciBkYXJrLCBlLmcuOgoKdzMy
LXN5c3RlbS10aGVtZToKKiBuaWw6IGZvbGxvdyBzeXN0ZW0gdGhlbWUgKGRlZmF1bHQpCiogbGln
aHQ6IGZvcmNlIGxpZ2h0IG1vZGUgKHRoZSBvbGQgYmVoYXZpb3IpCiogZGFyazogZm9yY2UgZGFy
ayBtb2RlCgpTZWNvbmQsIGNvdWxkIHlvdSBwcm92aWRlIGFuIGV4aXN0aW5nIHZhbHVlIGZyb20g
ZWFybHktaW5pdCB0aGF0IEkgY291bGQgZm9sbG93IGFzIGFuIGV4YW1wbGU/IChJIG5ldmVyIGtu
ZXcgZWFybHkgaW5pdCB3YXMgYSB0aGluZywgc28gSSBhbSBnb2luZyB0byByZXNlYXJjaCB0aGlz
IC0gaXQgd2lsbCBwcm9iYWJseSBtYWtlIG15IHBlcnNvbmFsIGluaXQgY3VzdG9taXphdGlvbiBh
IGxvdCBiZXR0ZXIgdG9vISkKClZpbmNlIFNhbHZpbm8=




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 30 Oct 2021 10:34:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 30 06:34:35 2021
Received: from localhost ([127.0.0.1]:56698 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mglh4-0002MO-T3
	for submit <at> debbugs.gnu.org; Sat, 30 Oct 2021 06:34:35 -0400
Received: from eggs.gnu.org ([209.51.188.92]:53532)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mglh0-0002M6-LW
 for 51404 <at> debbugs.gnu.org; Sat, 30 Oct 2021 06:34:33 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49874)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mglgu-0007Ld-Sy; Sat, 30 Oct 2021 06:34:25 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=z7UNLMFNsRInpla7uQ88OznF9QbnYxJoBI3R4fb8c3E=; b=PLJ3dfCltQlO
 Sqtsn8lA+wNsy+/xQFG4/UldUkFZ4xpA95hQq1PLf1ge9PmRpcCYeN08CK/Fhq5N8YSgnj9tJAMUR
 E7MCKNkx4WYkbOW6tPBHK2ry5WU7Z/b1dNlu741NA9ukwEZibGfM3IzT4Fv6mHVMuCcY0Ao16Lleb
 BcbfREB6NwNBPoZZ6VDrc3Bi/RzFT0sdbpenFulKJcQwfCWeEloXZ8mdwwkfJdsDB+dT0E78bLKEY
 cfPz7W2LkzlBqLmz1fZOEJI77q3sDh10MWd5kCOLv1HIh0cHeAS8pilrFRt4Cwru+EHZre2P4THMU
 XJjFsl7ulFfUTxxLyv+otg==;
Received: from [87.69.77.57] (port=4685 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mglgu-0000dM-DY; Sat, 30 Oct 2021 06:34:24 -0400
Date: Sat, 30 Oct 2021 13:34:12 +0300
Message-Id: <83a6iqpzrv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: salvino@HIDDEN
In-Reply-To: <83r1c5tyar.fsf@HIDDEN> (message from Eli Zaretskii on Thu, 28
 Oct 2021 10:15:40 +0300)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 <83r1c5tyar.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: 51404 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Thu, 28 Oct 2021 10:15:40 +0300
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 51404 <at> debbugs.gnu.org
> 
> > From: Vince Salvino <salvino@HIDDEN>
> > CC: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
> > Date: Wed, 27 Oct 2021 21:41:05 +0000
> > 
> > Update: I managed to get my hands on an 1809 system and was able to get dark mode working there as well. As far as I can tell 1809 is the absolute minimum as that is when this setting and dark mode Explorer were introduced into Windows.
> > 
> > The advantage is that this will now work on Windows Server 2019 and Windows LTSC 2019, which some folks may be limited to as those are the latest Server and LTSC releases.
> > 
> > Attached patch includes the complete change, with relevant notes etc.
> 
> Thanks.  Your legal paperwork also came through, so I will be
> installing this soon.

Now done, with a few minor adaptations to our style conventions.

Please in the future accompany your changes with ChangeLog-style
commit log messages, as described in CONTRIBUTE.  (I added those for
you in this case.)

Can we now please implement the Emacs-specific user setting that will
allow users to opt in or out of this feature?  Here's what I suggest:

  . define a variable exposed to Lisp using DEFVAR_BOOL; let's call it
    w32-follow-system-theme
  . move the determination of w32_darkmode from globals_of_w32fns to
    w32_term_init, and make it depend on the value of
    w32-follow-system-theme: only set w32_darkmode if the variable is
    non-zero
  . document that users can customize w32-follow-system-theme in their
    early-init file (which is processed before window-system
    initialization that calls x-open-connection)

WDYT?

(Let me know if you need help in making any of the above happen.)

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 28 Oct 2021 07:15:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 28 03:15:48 2021
Received: from localhost ([127.0.0.1]:51210 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mfzdc-00023q-DK
	for submit <at> debbugs.gnu.org; Thu, 28 Oct 2021 03:15:48 -0400
Received: from eggs.gnu.org ([209.51.188.92]:52088)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mfzda-00023a-9t
 for 51404 <at> debbugs.gnu.org; Thu, 28 Oct 2021 03:15:46 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39534)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mfzdT-0000tc-Uo; Thu, 28 Oct 2021 03:15:40 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=s1PIvVbY4fhiz9a4eknRZmYpe0+nTeaghXNa//NEWoQ=; b=Wysjzj7oKwSR
 i5+Fzwy+feWsuHWibuCdlmWF7yUmt/lJNQbaOtLq0vcBTWUFgsB06FFQKcwjfY76cjfeSFqOEOpP+
 1sjvjBImQvpYV97zJEsNI4ZeG9yTqOT/fOXLoxF+qRRVi4MyGjJgV8yYPuIFjRyaA6E12PltdXlDK
 oA//vbJiCIBFg/vrWoWDkbS3pN7hPu9vyB9dGjDC5KAe4T4Zsn8ffWUD+jQsH4mRxVeLDIflNnzb0
 FDym7hPCPuYwPx/MKtCNudDRAC7eof6joGnjcmrfJFJfJr4b7owzHnihavHrGfBH8PDCWfblS1Hyl
 u5emHl5DAs0HwMILOoxzRw==;
Received: from [87.69.77.57] (port=2661 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mfzdT-0008BT-Fw; Thu, 28 Oct 2021 03:15:39 -0400
Date: Thu, 28 Oct 2021 10:15:40 +0300
Message-Id: <83r1c5tyar.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Vince Salvino <salvino@HIDDEN>
In-Reply-To: <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
 (message from Vince Salvino on Wed, 27 Oct 2021 21:41:05 +0000)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
 <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: 51404 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Vince Salvino <salvino@HIDDEN>
> CC: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
> Date: Wed, 27 Oct 2021 21:41:05 +0000
> 
> Update: I managed to get my hands on an 1809 system and was able to get dark mode working there as well. As far as I can tell 1809 is the absolute minimum as that is when this setting and dark mode Explorer were introduced into Windows.
> 
> The advantage is that this will now work on Windows Server 2019 and Windows LTSC 2019, which some folks may be limited to as those are the latest Server and LTSC releases.
> 
> Attached patch includes the complete change, with relevant notes etc.

Thanks.  Your legal paperwork also came through, so I will be
installing this soon.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 27 Oct 2021 21:41:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 27 17:41:17 2021
Received: from localhost ([127.0.0.1]:50735 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mfqfc-0007i3-Tg
	for submit <at> debbugs.gnu.org; Wed, 27 Oct 2021 17:41:17 -0400
Received: from mail-bn8nam12on2084.outbound.protection.outlook.com
 ([40.107.237.84]:17761 helo=NAM12-BN8-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <salvino@HIDDEN>) id 1mfqfa-0007hj-41
 for 51404 <at> debbugs.gnu.org; Wed, 27 Oct 2021 17:41:15 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=RlS7kdsVvnaYRwdE7pmnmV5/SqXb/7skcA4ILrtasTNUhI2ppcy9MyZxpYk67lrru7JJzish8vDukuwHvERJl0vLj/qU+Q8DYybN+vtvg9oCsXP3KLftQooyaLbz3GtEiSHhFUnxhuSoRQCvY9aCRO66CYRhAjaFEwliWK8Fp3VnnJF7jbimRlOIlfm+yjDjkbcqebLuEus63+Gd6sXoYEiy6BEsV8OkaKAaala8PWgDS0bpH6b1lLVXht4QpbZTa4RZ5wxqm5oYvy1EnUFrEZ5E/PW63H8JpY0fqWXIfyKJnSqrITpawddbB4v9qT64Yk8hs8nmvU0sxC7y30IwPg==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=Rd+GxbLR/nYY52lk6QQhnb/vCFkgMTd5R+2DDj8HOFE=;
 b=e9lVOfKXXbqf9flrjF0qx6wbFW+wn7okJUOoTJcbP6DpWDAUKr1s07kUz4cyVaQwpUmdC7IE17Bn4jdBnhix+BYYz66jc9IL3XQPjPPi4teSD30T5RMZmLtbqjO0lHDW3WRaF3VXV9AEclTGZxa994yqtgUpceKsqK98gHd/dpqRqRQg4q7ek4R7JG1ZSwoFWuhhxNfddpmf+EMjLOehNiybyVpDxb8PANcUtIAfwhJeo/o3fwoK7a3SfnmJdNpBLbrZtDISYYaizCmyKlTjKjN5g4/VE8gUL5iB/AeyCjtrpqgXSmRfv4VDEX+sPHPhpkStHqhQR5Ulz5vo5k0n5w==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=coderedcorp.com; dmarc=pass action=none
 header.from=coderedcorp.com; dkim=pass header.d=coderedcorp.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=coderedcorp.com;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=Rd+GxbLR/nYY52lk6QQhnb/vCFkgMTd5R+2DDj8HOFE=;
 b=s6pesNRGETHkgl3uvs2aIqZC3vdwhSfjtFOioOxMGLAcZmEH6JuOst+DlS0n7y1TiPlrFw0Z2RhPthAQ2uencupt/zVuwVLFBcLfCDRkKnFfSzC6jHsXheANA8yPoKmrbXXBaaf/auXvw/XgQGlJgUlYztJ3VAKC278guMObBKM=
Received: from CH2PR12MB4231.namprd12.prod.outlook.com (2603:10b6:610:7d::24)
 by CH2PR12MB3829.namprd12.prod.outlook.com (2603:10b6:610:2c::18)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4649.14; Wed, 27 Oct
 2021 21:41:06 +0000
Received: from CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b]) by CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b%5]) with mapi id 15.20.4649.014; Wed, 27 Oct 2021
 21:41:05 +0000
From: Vince Salvino <salvino@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: RE: bug#51404: Support system dark mode on Windows 10
Thread-Topic: bug#51404: Support system dark mode on Windows 10
Thread-Index: AdfKJC1fFkosmLKeRpu5RIGxKoA2egATeE0VAAVMuSAAARwnVAACGfogADmStWA=
Date: Wed, 27 Oct 2021 21:41:05 +0000
Message-ID: <CH2PR12MB423138F5C432C2BBF330BC6BA5859@HIDDEN>
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
 <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
In-Reply-To: <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
Accept-Language: en-US
Content-Language: en-US
X-MS-Has-Attach: yes
X-MS-TNEF-Correlator: 
authentication-results: gnu.org; dkim=none (message not signed)
 header.d=none;gnu.org; dmarc=none action=none header.from=coderedcorp.com;
x-ms-publictraffictype: Email
x-ms-office365-filtering-correlation-id: f5d5bc65-216f-4e09-7885-08d999927b21
x-ms-traffictypediagnostic: CH2PR12MB3829:
x-microsoft-antispam-prvs: <CH2PR12MB3829C09E878361DA4FCCAE7FA5859@HIDDEN>
x-ms-oob-tlc-oobclassifiers: OLM:9508;
x-ms-exchange-senderadcheck: 1
x-ms-exchange-antispam-relay: 0
x-microsoft-antispam: BCL:0;
x-microsoft-antispam-message-info: MEjFKDryO0130w4JwoyIsIpOggi5EWrfSbo5yylSJ2tCH5kbbzJoq/FOsmzd8hy8+hpi7zi+H9nOddKIUh9wswRcb7yyAxA9y2bbiQaGvoxlFpFhIF3EHqHueZrrvCCgI59l9J+AbM0cEGDYYtGzf6/yyX9jdjEDybCx4JvHH5U+2icScTwo7AXKA/4Uam8DyHQfx/D6N179bgjjk30UzCBOtPj75ImNeXyMI9FkUzqmQPR4xuD3nSmdDiifaBzaMjd7ghhFye4cVajzS6zm2m6xPujbwlKziYmW6pGjsC3G7vJg4lXQiny4BH3aFN53aWzqQpx543sB524c07cTNVktqecWY66QffgM/4uCPnF5L+YxmlfOQ8IbtaYLFS1fEwkEgMR9/yVW+9xxxWM7b5szqLtRomHh6Ka44Han5bhG5EFtadcTDQ99lgD9yBkGC7Fi73YUODuryw4kUvMLr+zRdLYNX7Y04HCddEXpbomoUqHE6onafghrJt+OwyxEJCMEGbJiCHRW6XhhIEXPOJNAbr6DhtsXaav8iy+mkiws7z6DuyXcEydLUHVGXXdbAwEW+mpNRGhrTN+vrv8LYrlFLyF2sCD/lsqB+4tNbrW7fDeNeDikD/lg08lC1K2oYVnDwGoWM2107zOCgz7AcsJscs/hN+BAtOxYH8NR6+rkmILFaAUvv4CQtLpawCaLNpHDsCWfVXOacsotCY34pQ==
x-forefront-antispam-report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:CH2PR12MB4231.namprd12.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(346002)(396003)(366004)(136003)(39830400003)(376002)(186003)(26005)(52536014)(2906002)(38070700005)(316002)(5660300002)(55016002)(4326008)(71200400001)(86362001)(4744005)(508600001)(122000001)(9686003)(38100700002)(33656002)(8936002)(76116006)(8676002)(6916009)(6506007)(7696005)(99936003)(83380400001)(66476007)(66556008)(66446008)(64756008)(66946007);
 DIR:OUT; SFP:1101; 
x-ms-exchange-antispam-messagedata-chunkcount: 1
x-ms-exchange-antispam-messagedata-0: =?us-ascii?Q?PeexX7SW031/fM1+yUD/mZVAwgaF0Qu1ck2KXcTo8iFT2C4hI79TLjxB6rjY?=
 =?us-ascii?Q?RrzTivqZMmuCZuxYoXdFX2g4TCTqMr/bdXR0WxYA4ZTcji2z/Ticojzt1bvI?=
 =?us-ascii?Q?r0XeAgACsk0bUxIKL7rxdLEjk6NHiP0WxiCp3+ckBsbMosLEfBwBEv9LTwS0?=
 =?us-ascii?Q?qW4gdlIzI3ZNMHiz4fcBxucgLFW751R8JUWfP6x0houysn/yt7e84BzXWvWU?=
 =?us-ascii?Q?s40FVUZtBBZ5+KWTLErPfVPlIPPBxPQwxkP8teQ5QAnOziUDEQ9aBzRuuFao?=
 =?us-ascii?Q?KKiDLbYFubqSzJaCCN4f9GbwwNjkx84m3NX/qbWvR2h5Xz5I/K5WkOhN//aU?=
 =?us-ascii?Q?7GTdkFp8/XVDfsfqwSd28ToUzICqizO8wvKyVldsJEZfu62e5WrSFOLsHlxI?=
 =?us-ascii?Q?DpQdokvhASss0802JSPlATZJJiNPSemkmxVmfSy2bvxkRFJMvOlLJTTMabeY?=
 =?us-ascii?Q?vgphZK8YKpkKUlUZML1X0mpD/cRdhPN3QdrJQz7RDde7qJa2dy32y6ys5PXG?=
 =?us-ascii?Q?cEIe6DzTJJ/EvB9xCemVUzLvYttA2dKFX1KAqyKk9BHMND7UWOIAO9NZ+PzN?=
 =?us-ascii?Q?shbDqmbLnjcXhuS+d4mtzrmnVcERzDt8qfysH6AZRiQjc1zIpIa1LZTQapKH?=
 =?us-ascii?Q?LsDUhwniosz8Ma8IJX0xZRdMsudx2sgdNljYm1n3MoEve9ASbCNl26igPqVv?=
 =?us-ascii?Q?CIx5++Gv2yLRiwMci+VAoSgOSCL/GQPTNteFOA5HOJbaeFuzPdAtkKicMoDf?=
 =?us-ascii?Q?HLnxltWHUlcxl+tNM1/QvQHecReNoU+VdT3vFOjEGYdMy3afQwdVVfgGXK2i?=
 =?us-ascii?Q?IOoGk1RV6DmrpKglF5HxfB7QD/1OYZQbAq6hNJr8glEyurBcNIhlLnHtY7/g?=
 =?us-ascii?Q?8cO6XVc/ZsKTuAYxPBRFHhMpMeOcBtJXP4VP3kYodl0+6+2f4s5eFYmtoGgf?=
 =?us-ascii?Q?hTD0dfIDDqMfE42WW54uIxpS2bTOa4YKHMZrQpp6VPCrqdEZELgBZX8Ai6c1?=
 =?us-ascii?Q?JfhBa6mchh0+1jQl45FlAADUGe0qfj1KRv6oDHVVUPbrcFQdcpUi409cWJKP?=
 =?us-ascii?Q?1kCPsLpvWWpevhF8hICx1zTfknRKnN1E86oBMLNEzunJw83r+K3jt5HCkltV?=
 =?us-ascii?Q?kmQtOYRPqQ80FZ5QnWES2BjokSDYX6UvJZqUoEaoQm379TBwvbp5IKKVCGkk?=
 =?us-ascii?Q?q75QDtC/rNacaiUIt/kd385TvEeqWIP+iZWsmD/qst82VLXZIhdtD3ViZyed?=
 =?us-ascii?Q?ijgnzV3jf+ZhDU+W6xYznLwK7QeVnrJaMGUnuXYIArbHkgd9Ghwa/gKkVD7J?=
 =?us-ascii?Q?EdAvAWmqjnFdzEda/G+YgLBq13AMFqb97MtnnXJAqIVbFI4qN16vmZotrALH?=
 =?us-ascii?Q?74EjISoTr8TTajYYdcD9ytGAtkF36qXj+CDJ8kEOkr1UYfcI/hHa5PHPwNWm?=
 =?us-ascii?Q?oIx7o2sLHgdRy2/E6sUE2aa6FeGcRe9b1+0xlFbrlyduOgX9zleYMm493xse?=
 =?us-ascii?Q?w/nq3EttIbboewm5rxXfT8nOhqXtzQ5UpsIvYpkqExuUaScHk/ximJ6X+FO7?=
 =?us-ascii?Q?G/FXIfluZ8ejzbu8bzG1JYFtZ1fpc55JCVVuRJ3kt+RyQ6hqYvDNKDyrnzPv?=
 =?us-ascii?Q?C2FtJ5LknyUo4h9rnVL5zyU=3D?=
Content-Type: multipart/mixed;
 boundary="_002_CH2PR12MB423138F5C432C2BBF330BC6BA5859CH2PR12MB4231namp_"
MIME-Version: 1.0
X-OriginatorOrg: coderedcorp.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-AuthSource: CH2PR12MB4231.namprd12.prod.outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: f5d5bc65-216f-4e09-7885-08d999927b21
X-MS-Exchange-CrossTenant-originalarrivaltime: 27 Oct 2021 21:41:05.8437 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Hosted
X-MS-Exchange-CrossTenant-id: 9c94adb1-2ce8-484f-be82-c9b5127d4cb1
X-MS-Exchange-CrossTenant-mailboxtype: HOSTED
X-MS-Exchange-CrossTenant-userprincipalname: 5xdpqDYQ6tmk00CRREA0F6LRKMFLNNKMC7olYvzfMFsLlaLSa9s4EGj7azGmAUnMV5D72/XFS/QsMtYygnULAg==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: CH2PR12MB3829
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51404
Cc: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--_002_CH2PR12MB423138F5C432C2BBF330BC6BA5859CH2PR12MB4231namp_
Content-Type: text/plain; charset="us-ascii"
Content-Transfer-Encoding: quoted-printable

Update: I managed to get my hands on an 1809 system and was able to get dar=
k mode working there as well. As far as I can tell 1809 is the absolute min=
imum as that is when this setting and dark mode Explorer were introduced in=
to Windows.

The advantage is that this will now work on Windows Server 2019 and Windows=
 LTSC 2019, which some folks may be limited to as those are the latest Serv=
er and LTSC releases.

Attached patch includes the complete change, with relevant notes etc.

Vince Salvino


--_002_CH2PR12MB423138F5C432C2BBF330BC6BA5859CH2PR12MB4231namp_
Content-Type: application/octet-stream;
	name="0001-Support-system-dark-mode-on-Windows-10-version-1809-.patch"
Content-Description:  0001-Support-system-dark-mode-on-Windows-10-version-1809-.patch
Content-Disposition: attachment;
	filename="0001-Support-system-dark-mode-on-Windows-10-version-1809-.patch";
	size=11202; creation-date="Wed, 27 Oct 2021 21:32:16 GMT";
	modification-date="Wed, 27 Oct 2021 21:32:16 GMT"
Content-Transfer-Encoding: base64
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--_002_CH2PR12MB423138F5C432C2BBF330BC6BA5859CH2PR12MB4231namp_--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.
Severity set to 'wishlist' from 'normal' Request was from Stefan Kangas <stefan@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) patch. Request was from Stefan Kangas <stefan@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 26 Oct 2021 18:20:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 26 14:20:46 2021
Received: from localhost ([127.0.0.1]:47538 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mfR42-0007vr-2S
	for submit <at> debbugs.gnu.org; Tue, 26 Oct 2021 14:20:46 -0400
Received: from mail-bn8nam12on2074.outbound.protection.outlook.com
 ([40.107.237.74]:26848 helo=NAM12-BN8-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <salvino@HIDDEN>) id 1mfR40-0007vc-AI
 for 51404 <at> debbugs.gnu.org; Tue, 26 Oct 2021 14:20:44 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=FEmjLJyJQHl8jj8ZvV0wL8/zUFAR4BmYo+4ihdoMg/f5FA4GY2rjq3hhZ4WrCXSQjDgOCEsk6uCxYpVsNnX8b9saGtFD7cu0SWzac1esfWnhju+P2XB6BAQplv++OJyYMeupWZf+Fx+L5MC9LUaTZlKLigWeuyrKZKCOU8EjBnf/6UeICXfmFtCYtTnKD9qu2E/dVtsQ6vivXF9Ix5/Wbf2d12S0PCwiraivE8WOkzser8BPSkK2m2zBzGZ/r4hi1a6rAQgfG//ZdZLMMBZbGy14Y0mBDQ2Mdwv7mDO1KhXttqOeub0Fvn192YJjBa9/ELJPfSsWujFLmLDRElx+8Q==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=tyiGOIAMRL/aMC3rkRXt91XaQBkS4HJ93MopFaTtLH0=;
 b=IpiDsQJ0nIdJho1NVIJuwlxh1sXhH3ju9tnWU7MWGXFo8hNQ0QqsnriAzQFPDnG61LeSt3OlGHY4VN90n7Vw/42+Xc93moZY3Mf9jfco83D1WJ6XnMQ0yc4eXa9W1Zogac0yvvEiDBQX2TV68qqJQ/64wFeSegxbxKM+e8i0WKN7o1FpePGnolO4z5uPwPRh4NXuX8SITzg7Dczn4Evs6nDuDhHOj8q/EOk6eH1pvx/azdeq+DG54aYA6ceBZy48topIWB9+dnCHeqyhjKYMXc5VQqIpClo5tfD0UsJppW/AiONDliFs+jf/Mida6Q8kJatenH5UaQPf+JwqKuwiOw==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=coderedcorp.com; dmarc=pass action=none
 header.from=coderedcorp.com; dkim=pass header.d=coderedcorp.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=coderedcorp.com;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=tyiGOIAMRL/aMC3rkRXt91XaQBkS4HJ93MopFaTtLH0=;
 b=q8DhPzItlXaEceh/rf/FbzlIS8FvP6K1mFmRggWfdCAPK5aDeU9zSo3p7AAi2kOAslVi2yaDMpodkJHTDj7iBowOKCRe98iZ5VoUkiSWINpRb2BJjrYoLcQZbXoSHRe3dEsKN75KlfBhTrijlJKswW4wyRcRPijmt9jugAP+f14=
Received: from CH2PR12MB4231.namprd12.prod.outlook.com (2603:10b6:610:7d::24)
 by CH2PR12MB4021.namprd12.prod.outlook.com (2603:10b6:610:2b::29)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4649.14; Tue, 26 Oct
 2021 18:20:36 +0000
Received: from CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b]) by CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b%5]) with mapi id 15.20.4649.014; Tue, 26 Oct 2021
 18:20:36 +0000
From: Vince Salvino <salvino@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: RE: bug#51404: Support system dark mode on Windows 10
Thread-Topic: bug#51404: Support system dark mode on Windows 10
Thread-Index: AdfKJC1fFkosmLKeRpu5RIGxKoA2egATeE0VAAVMuSAAARwnVAACGfog
Date: Tue, 26 Oct 2021 18:20:35 +0000
Message-ID: <CH2PR12MB4231BF93A366641B94D7A636A5849@HIDDEN>
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 <838ryfyawv.fsf@HIDDEN>
In-Reply-To: <838ryfyawv.fsf@HIDDEN>
Accept-Language: en-US
Content-Language: en-US
X-MS-Has-Attach: yes
X-MS-TNEF-Correlator: 
authentication-results: gnu.org; dkim=none (message not signed)
 header.d=none;gnu.org; dmarc=none action=none header.from=coderedcorp.com;
x-ms-publictraffictype: Email
x-ms-office365-filtering-correlation-id: 09f3a8c4-0c84-45e7-258c-08d998ad4e52
x-ms-traffictypediagnostic: CH2PR12MB4021:
x-microsoft-antispam-prvs: <CH2PR12MB4021FAC3E1324BA2DFC9B0B7A5849@HIDDEN>
x-ms-oob-tlc-oobclassifiers: OLM:10000;
x-ms-exchange-senderadcheck: 1
x-ms-exchange-antispam-relay: 0
x-microsoft-antispam: BCL:0;
x-microsoft-antispam-message-info: M0fKjSPN/Nv2WeVohTOQAgK8sz/9y4HEfSe0z47sTJw6FEyxd2GRhgYpDMdfLAvTxTEHvLYhfyfJhqtnb13YgajI6Hb0ogI73VvlXkgbnYhgvdVi3l41vTA7LrXenzeDHR5snnyS6TJVXGULmrBw+ZJKpQ480PE50gzN37C1xQIhbg8gIHJ7OSoeSphTTeC8WNbwulhjIEsoGcHueXtmklaWMhePR6FMxxOhBQd0Plb6BPxJmR6XPGpyxqPpvOaidlGophKIhIFhdVaLSK0N9radtoRP7aPH5hfT7pYT33biYu/7YxheyFDXNrtCV93aq5ibNfmbofISVKkTpWsVRXbHeNSUGp6x/zeYSmSQYXdiiAeZz77etmbucb6PAjTnH/E49mKH8KF3s+HuKE/AH1IJHklp4+P/dt847re1UPHBI+6ovfUljelws63nfb56NKpddKbvhiiuR8bk0LNPEVveY4s+jP/wUDXGO3JAmOOMJKe/FIjQaPSKLFGuPiRi16p9/R13mWN4UC0cy4HHdz73G4e0RMsbvk8xlYFtjf7TjwROsloZUFBtdQrz/X4dqiCgHGlNPpQqzrdCNOjWh3OdwUQ3q5VM7z+Ju9DN+f32FZioqO0uP0W3YZwH/Xuss81k/dKwr2X7nLf1wdm6wglnqqdbJUmNiduS7+aWvGedCmXUUFghtIV6i+KSNl8ItSzW70qx7AsYTeGTyWK08FJGoDD2JdoTe3958BLQABrkNTihVBYddaS8FwlrwnmVE4amADwcKAQOwfmE+X1uRgEuMWapkV2Pr7iNpeHr12A=
x-forefront-antispam-report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:CH2PR12MB4231.namprd12.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(366004)(136003)(376002)(396003)(39830400003)(346002)(966005)(8676002)(508600001)(66556008)(66946007)(66446008)(66476007)(7696005)(64756008)(316002)(6916009)(83380400001)(8936002)(52536014)(186003)(86362001)(99936003)(76116006)(33656002)(71200400001)(6506007)(53546011)(2906002)(38100700002)(26005)(122000001)(4326008)(9686003)(66574015)(55016002)(5660300002)(38070700005);
 DIR:OUT; SFP:1101; 
x-ms-exchange-antispam-messagedata-chunkcount: 1
x-ms-exchange-antispam-messagedata-0: =?us-ascii?Q?G2GOdIkRgMUxnPNHuMCKOpFNTkNAYkPC05vLMInWMYamcixF0A4/nlIhIOm5?=
 =?us-ascii?Q?ZwbcdikDMFPcFwLBG4mrp9+m2PIS/tvVZWYzmTgxkMOldSboDIj0hLXIxRbn?=
 =?us-ascii?Q?Z+flu0sH8QDxPmF3MmrlQGCvKwV6CfRk0+h+CIb+OxibEPG2YomX+PydYpkq?=
 =?us-ascii?Q?xh+88Fkp0GJM9kYm+Y+CC+HsUBTT2nv3JQYFfBwGM0NHuY6VKG2iOEpwzXGS?=
 =?us-ascii?Q?j1HftHwP9rX+msMfKaI0dw4x/DwbIM8jNVDlX1G6ZnTN9oX9ksm5kN2MOAsl?=
 =?us-ascii?Q?nVaJhYy0ztlaJKj9AV3N+uHvmFNLAEo1VqV7tClgtTeMgrwqouj+ra5jVmVl?=
 =?us-ascii?Q?zkVr4ZZpOSYcgYOtoMHtwREYZqGvGFMF0rYMF2O1992jvk5ul8BZ5MCZDejL?=
 =?us-ascii?Q?+ZxBtzoa0gsX0lYh8pP8azhu2BoQHu/heNd96W63FEc8s0xLJltLeoQjlQ5q?=
 =?us-ascii?Q?eNAI/s/CiHjytLRzy2GDaydNQHlRHeSMoRNdFeWe/VRvYidXEo+ZcHvxPSiD?=
 =?us-ascii?Q?gvStNDdWytvM21P7U4LGf/dFk3JcurzrsTwpZdZbHk6mU8d5Q22Q6RXvV2L9?=
 =?us-ascii?Q?2tIiG0eTV0gJYyHjElCKxOoBZFueCnYb1cGMu3NaVDgfAMD59oOFnffycDSw?=
 =?us-ascii?Q?ul9Vy+iu4VeaBpUmdrwXpCwvoRvZ7pFglBvwjgiod0FWzQbyN9CRK5Ywh3c6?=
 =?us-ascii?Q?y2gwMkDZ0BlizmKJqUzsTQWbGkuMGRMup6FpGK3JX5f2zqHuNliQAS1OKbOT?=
 =?us-ascii?Q?vbLaXrqhlzni9nuJL7ppu+lr6BHgORxLRy/K7UTYhzO/z2ZT2xWN62/7lOcm?=
 =?us-ascii?Q?bQSWQ65uN9fwE6GmyFBW/nk6XEDhll0edQNaD1VVNhwbNAqRCESstP6J93wY?=
 =?us-ascii?Q?xkRQwGS+0aEPMX1DdXObPfq3QdbiZayRhqooWFgz3doNRgtWbQD0LSOVEwN0?=
 =?us-ascii?Q?xsoKXGoLDJEyJlEQJ5FiKODl0hXwDBDA7Tn6H3PEu4V60QYyy/dkbf4EyrTG?=
 =?us-ascii?Q?S1SBVF80aTTyc0v0Q9u8BX9sdLYRzFwMwjm+cQUWvx4W1aCLhN6WnL5z0ueN?=
 =?us-ascii?Q?Sm+8Rs1C7ii4rQLLfNbyAkbLtMT5WJ+eIBxUNHW05VRa3KcCb/uoNWPOdfEn?=
 =?us-ascii?Q?Qws8rt12JG+9YJvW2F1DQYPVf3qUNHf4Yyde951zzrC9jPepvmKukFtl/xOD?=
 =?us-ascii?Q?wHacEOA4ehmX7zSVIgJzQtsGZxariuh8dXm9uzdL5tOGKgA/7Gu2Srjxq7kQ?=
 =?us-ascii?Q?GOqTHFcCT58jN7aLOGpA9T0aFvry1xMayuzp5cUaFXs/moByHW/F6zvBpoHk?=
 =?us-ascii?Q?aTgGeingEFIMuhazd5pcL6ZLk0zn0gDr4vZY2RvHoQ53XNS9QM1dS0T06Jt9?=
 =?us-ascii?Q?4Izyk80hrJaiRdPAcciBpXK9L5hyH6nB0d6sdCRBjshNo6FOOOaCh5o/4DNJ?=
 =?us-ascii?Q?c64LT0KbH7/pZaWZFZP5xRECOk1GDLU5VrRClbYDaVw/0n2Hr58QEFY6Q1LV?=
 =?us-ascii?Q?Pn+8T+Q2Ugt4jFSQnyezqaSHF4PQJAxzBCFEZso5233DiLx7u8yB1DW6/9UU?=
 =?us-ascii?Q?Tt59sCfhuqMS6JfS0g7hvAjFloGtImWX57xLfpYKi1MZvV/jIcuf5QyJ36Ye?=
 =?us-ascii?Q?qQ=3D=3D?=
Content-Type: multipart/mixed;
 boundary="_002_CH2PR12MB4231BF93A366641B94D7A636A5849CH2PR12MB4231namp_"
MIME-Version: 1.0
X-OriginatorOrg: coderedcorp.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-AuthSource: CH2PR12MB4231.namprd12.prod.outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 09f3a8c4-0c84-45e7-258c-08d998ad4e52
X-MS-Exchange-CrossTenant-originalarrivaltime: 26 Oct 2021 18:20:35.9430 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Hosted
X-MS-Exchange-CrossTenant-id: 9c94adb1-2ce8-484f-be82-c9b5127d4cb1
X-MS-Exchange-CrossTenant-mailboxtype: HOSTED
X-MS-Exchange-CrossTenant-userprincipalname: HUU41ZFohWmT3NN3h6FlJC2a+Ku7uYlfD/ZvIwuqwWmfhIJJ0mVU3MR18WUIYg3n0vh8evEbEFkpYsmWf83kwQ==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: CH2PR12MB4021
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51404
Cc: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--_002_CH2PR12MB4231BF93A366641B94D7A636A5849CH2PR12MB4231namp_
Content-Type: text/plain; charset="us-ascii"
Content-Transfer-Encoding: quoted-printable

Attached is the patch with some of your comments resolved.

Regarding exposing DARK_MODE_APP_NAME to lisp, I am staunchly against that.=
 If users want to potentially segfault their emacs, or make the frame invis=
ible/unusable, they are more than welcome to play with the C code.

Regarding toggling dark mode from within lisp, I think that is a decent ide=
a, and left a TODO in the relevant place in the code. Help would be appreci=
ated here. The current functionality is not "unconditional" per se, it foll=
ows the user-configurable OS setting (which is light by default, so no visu=
al change from previous versions of Emacs). The manual has been updated wit=
h a relevant note.


Vince Salvino

-----Original Message-----
From: Eli Zaretskii <eliz@HIDDEN>=20
Sent: Tuesday, October 26, 2021 1:06 PM
To: Vince Salvino <salvino@HIDDEN>
Cc: 51404 <at> debbugs.gnu.org
Subject: Re: bug#51404: Support system dark mode on Windows 10

> From: Vince Salvino <salvino@HIDDEN>
> CC: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
> Date: Tue, 26 Oct 2021 16:49:34 +0000
>=20
> > > +#define DARK_MODE_APP_NAME L"DarkMode_Explorer"
>=20
> > Can we make this exposed to Lisp, rather than hard-coded?  Hard-coding =
a specific application for a theme sounds un-Emacsy.  People could want to =
experiment with other apps.
>=20
> Given that this is not so much a preference, as an undocumented magic str=
ing in Win32, I think anyone who wants to play with this is going to requir=
e knowledge of C and gdb to experiment, to risk causing erratic and unknown=
 behavior. So I would be inclined to keep it in C.

These "undocumented" strings are all over the Internet, so...

Here are some examples that people may wish trying:

  https://stackoverflow.com/questions/19712368/c-winapi-old-styled-window
  https://developercommunity.visualstudio.com/t/tree-controls-not-displayed=
-correctly-in-windows-1/423037

And this is just from a couple of minutes of searching the Internet.

> > +/* Applies the Windows system theme (light or dark) to a window=20
> > +handle. */ static void w32_applytheme(HWND hwnd) {
> > +  if (w32_darkmode) {
> > +    /* Set window theme to that of a built-in Windows app (Explorer)
> > +       because it has dark scroll bars and other UI elements. */
>=20
> > Likewise here: it should be able to control this behavior by a user opt=
ion.  We cannot assume that every Emacs user will automatically want to fol=
low the system theme.
>=20
> I agree this would be a "nice to have", but the current functionality is =
in-line with behavior on other systems (GTK, macOS, etc. i.e. the applicati=
on has no say in window decorations which are controlled by the window mana=
ger). If we did add an elisp setting it should default to the registry valu=
e at runtime. I also have no idea how to create an elisp setting and read i=
t in C. Examples or contributions to this patch would be helpful.

The GTK behavior is a bad example, so I'd rather not follow it.
Doesn't the patch in its current form unconditionally change the appearance=
 of Emacs in some cases?  I think it does, and that means we will have comp=
laints about unexpected change in behavior.  You can also bet on someone di=
sliking the result.  So I think this has to be customizable; let me know if=
 you need help in doing that.

--_002_CH2PR12MB4231BF93A366641B94D7A636A5849CH2PR12MB4231namp_
Content-Type: application/octet-stream;
	name="0001-Support-system-dark-mode-on-Windows-10-version-2004-.patch"
Content-Description:  0001-Support-system-dark-mode-on-Windows-10-version-2004-.patch
Content-Disposition: attachment;
	filename="0001-Support-system-dark-mode-on-Windows-10-version-2004-.patch";
	size=10781; creation-date="Tue, 26 Oct 2021 18:13:08 GMT";
	modification-date="Tue, 26 Oct 2021 18:02:09 GMT"
Content-Transfer-Encoding: base64
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--_002_CH2PR12MB4231BF93A366641B94D7A636A5849CH2PR12MB4231namp_--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 26 Oct 2021 17:05:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 26 13:05:40 2021
Received: from localhost ([127.0.0.1]:47439 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mfPtL-0005mF-JP
	for submit <at> debbugs.gnu.org; Tue, 26 Oct 2021 13:05:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44676)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mfPtJ-0005m2-Ub
 for 51404 <at> debbugs.gnu.org; Tue, 26 Oct 2021 13:05:38 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35482)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mfPtC-0006pT-Iy; Tue, 26 Oct 2021 13:05:31 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=tH0ZACRUQa69l+CS8/IkBorb5SsdQaX2tS3NWCevcwQ=; b=L4n81o89NgtC
 fngNZNFM9yjW277z29O2aiWPRNl9b8RI+9SViRrQqHxyOviB5aEsY/Z1+cMZxMnUhqAv87qOtRUMq
 kJaCBArLy1f4M6OoAaYVFkWv88GynV0GNZfgmuL3UG5KUv99dHkEUYjnlVn/6O+BkNq9YpL+I4Lqu
 h+2R8MGXd69KAEZ4QVUFgu9r+7hA4vbxRvQQdP/AUG6SYEuCUSa/F48xlWtVryGvRvOhoxsGZ+d/O
 /KAWzKsT5S2I6ZPQzKIiUezfvlNgArf9k0ET4L3cirV4r8coxcfJgqG+wp4Wzlb/0cZ2O1SEFuoMC
 jwKogDmHQZcYuEjGLvZZpQ==;
Received: from [87.69.77.57] (port=4662 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mfPsq-0004dJ-Uh; Tue, 26 Oct 2021 13:05:27 -0400
Date: Tue, 26 Oct 2021 20:05:04 +0300
Message-Id: <838ryfyawv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Vince Salvino <salvino@HIDDEN>
In-Reply-To: <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
 (message from Vince Salvino on Tue, 26 Oct 2021 16:49:34 +0000)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN> 
 <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: 51404 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Vince Salvino <salvino@HIDDEN>
> CC: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
> Date: Tue, 26 Oct 2021 16:49:34 +0000
> 
> > > +#define DARK_MODE_APP_NAME L"DarkMode_Explorer"
> 
> > Can we make this exposed to Lisp, rather than hard-coded?  Hard-coding a specific application for a theme sounds un-Emacsy.  People could want to experiment with other apps.
> 
> Given that this is not so much a preference, as an undocumented magic string in Win32, I think anyone who wants to play with this is going to require knowledge of C and gdb to experiment, to risk causing erratic and unknown behavior. So I would be inclined to keep it in C.

These "undocumented" strings are all over the Internet, so...

Here are some examples that people may wish trying:

  https://stackoverflow.com/questions/19712368/c-winapi-old-styled-window
  https://developercommunity.visualstudio.com/t/tree-controls-not-displayed-correctly-in-windows-1/423037

And this is just from a couple of minutes of searching the Internet.

> > +/* Applies the Windows system theme (light or dark) to a window 
> > +handle. */ static void w32_applytheme(HWND hwnd) {
> > +  if (w32_darkmode) {
> > +    /* Set window theme to that of a built-in Windows app (Explorer)
> > +       because it has dark scroll bars and other UI elements. */
> 
> > Likewise here: it should be able to control this behavior by a user option.  We cannot assume that every Emacs user will automatically want to follow the system theme.
> 
> I agree this would be a "nice to have", but the current functionality is in-line with behavior on other systems (GTK, macOS, etc. i.e. the application has no say in window decorations which are controlled by the window manager). If we did add an elisp setting it should default to the registry value at runtime. I also have no idea how to create an elisp setting and read it in C. Examples or contributions to this patch would be helpful.

The GTK behavior is a bad example, so I'd rather not follow it.
Doesn't the patch in its current form unconditionally change the
appearance of Emacs in some cases?  I think it does, and that means we
will have complaints about unexpected change in behavior.  You can
also bet on someone disliking the result.  So I think this has to be
customizable; let me know if you need help in doing that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 26 Oct 2021 17:05:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 26 13:05:17 2021
Received: from localhost ([127.0.0.1]:47435 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mfPsy-0005lW-R1
	for submit <at> debbugs.gnu.org; Tue, 26 Oct 2021 13:05:17 -0400
Received: from mail-dm6nam08on2041.outbound.protection.outlook.com
 ([40.107.102.41]:13920 helo=NAM04-DM6-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <salvino@HIDDEN>) id 1mfPdt-0005Kg-VU
 for 51404 <at> debbugs.gnu.org; Tue, 26 Oct 2021 12:49:42 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=ARfMhP2ujAlxLeiF5gmfVsLiqUPZ3IRbszVojuZOg6psbcs/lru3RR1oapP1soEuw7v0N4TgrljsaRqnloT3ggcEc7PV+u/a2ZYa7268f/1JFHP6htU6F9o/V5dGE9DVJlUBF8Pu3eqBXFbdITomtDKxXX9X32mk1B9mm/YY6uGO1Tv9wcicqJBTw4dAGFlsGQXHDRV98lph32fnLhVGTsdleuDBf4pu43USa7f8Jct2r4JqiifKQJJ06Aujrs+CFbA0Wf6YMrcI8Yl/D4F34nH4NGq9IMPuzIFEqkay/quSRs+NEbngwbQsidiH/gjqzcL/IkeywyGGHdj6jd8a/Q==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=AYXuFW0vy6XRyeBPxGgcnaQuDvZtR9pRZXWQx+l04SM=;
 b=QIiI2pFHuWU+U4L9o7h17MYoRTHYot6K363HYuXgGyPJhpKihrSu1/l8Lp6Vxya8p1Sh7bS8AuGU7TUAe3WZ+sCyac20NMdnYHZyIT4wWq+nF+3FmVPtAacVcqxR39X1g1QqPMcQ+9iN2V6RMpBSOAwFWZP/6EcxzWNblj3Rgofuy6eR1CiAPMfz9SNLsCuUG/kpfF9fzR8jHPVjrqf4ei8lkmM/hdJ6nVtRMKp3uoFw5WB2ieDBh1skWYDCPbQe6MpB5hKmRaQf/7DmrwQAv93lmpH9VHMhOuAnhRdQe8UdwflqDfrsNDRMZzo+82MG/dmJqTGeiIb8XviTf+1xqg==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=coderedcorp.com; dmarc=pass action=none
 header.from=coderedcorp.com; dkim=pass header.d=coderedcorp.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=coderedcorp.com;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=AYXuFW0vy6XRyeBPxGgcnaQuDvZtR9pRZXWQx+l04SM=;
 b=dW3Rpdr4fr/e6vGI10UZeETCvEJG/zbiqfvZx6G8u2i03CaAqLiiVDvM7m6mWIrHDfjziIpw07qEgs1pm/rispqiu7PbGTjOygWU4XXMLQklOso/qcp+WKPp/aMog2ZIt+B/xgSzCuIaC3fK7LlPErt9Sg0SOBqCcCNsaoRv5Mw=
Received: from CH2PR12MB4231.namprd12.prod.outlook.com (2603:10b6:610:7d::24)
 by CH2PR12MB4277.namprd12.prod.outlook.com (2603:10b6:610:ae::23)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4628.15; Tue, 26 Oct
 2021 16:49:34 +0000
Received: from CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b]) by CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b%5]) with mapi id 15.20.4649.014; Tue, 26 Oct 2021
 16:49:34 +0000
From: Vince Salvino <salvino@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: RE: bug#51404: Support system dark mode on Windows 10
Thread-Topic: bug#51404: Support system dark mode on Windows 10
Thread-Index: AdfKJC1fFkosmLKeRpu5RIGxKoA2egATeE0VAAVMuSA=
Date: Tue, 26 Oct 2021 16:49:34 +0000
Message-ID: <CH2PR12MB4231BD9B939F3D485536A5BAA5849@HIDDEN>
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
In-Reply-To: <834k93zxyo.fsf@HIDDEN>
Accept-Language: en-US
Content-Language: en-US
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
authentication-results: gnu.org; dkim=none (message not signed)
 header.d=none;gnu.org; dmarc=none action=none header.from=coderedcorp.com;
x-ms-publictraffictype: Email
x-ms-office365-filtering-correlation-id: 52a00520-19ae-489e-b947-08d998a09719
x-ms-traffictypediagnostic: CH2PR12MB4277:
x-microsoft-antispam-prvs: <CH2PR12MB42775CE94663BD5A1E06BBA8A5849@HIDDEN>
x-ms-oob-tlc-oobclassifiers: OLM:10000;
x-ms-exchange-senderadcheck: 1
x-ms-exchange-antispam-relay: 0
x-microsoft-antispam: BCL:0;
x-microsoft-antispam-message-info: 6fLlBM1im0I5N3X4nwESMtxcTKX7gQy2nmLyzn7BltFiCccrVkEEd4ydWVzKgXZCTLkFU6xqPgVS1OfUz28AL8zI6RwSvO+eIXGxGP8WEeTjg1BcHi/cYqjmpdhN0MCRcRMXzJoo95m9hS/lCVi98ywprf4ky2tWNUzLRFUmFOdVrhf88V00iL7kwEqwLedQd2StlOZBWU+vBeqjGaD7k3Kl0wbhtJCq341NhRkEqT2GBOF1gmOFJ3pdn2Z8aP3hfjcCmbwEwPD5mF0yEs+ChDigDhbtTqJ/cp/w4Jnz7KnErTDKz8lb/veBCSBPanoU1dsOWimB6LzraZphKn3ArWlF+BxNIIsCexYGfgFaetEHtLlBAKDRbZz/oshV4odz8MyYSQP90grmdPNNhQMeVpf+sWD3E1goy+blqvR1woVThKXnY/TZYlWysIbNCOqNDoWcArJPtQGzLAS9mdKqXEg5EoY1D8l/zBmdPlPjeR+4fGAa+kF73l1k/uiH+nLI9j6N7eWA6Q0T4csiX6flW7SWnXjmb9NGScMgwLlfwsy1S+JYk+3dApfI1t0m8h+n+pTzaGvleiPTUyBof5uewzEK459NwzPmEDJSLBiFhR+HEC0jQ4lw+V+EZyiy53/CBGynKQTZEp3uHWGnt8sD6xT+yyPxaLLEVz2cfswlExZAbyZ32ywl7YmPqIhEzvQXGFgoP32FEBen/04GmDn3JTfMvJMD/MekaAh7m5392dWxJMaEbBzfwHlaxDkRq2lhehCUb3yabtR0FG/l44VJVXS+yNpCybWIxHlNw4qJTS0=
x-forefront-antispam-report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:CH2PR12MB4231.namprd12.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(396003)(39830400003)(346002)(376002)(366004)(136003)(6916009)(966005)(8676002)(508600001)(186003)(9686003)(76116006)(4326008)(6506007)(7696005)(8936002)(2906002)(86362001)(52536014)(33656002)(71200400001)(53546011)(64756008)(66446008)(66476007)(66946007)(316002)(66556008)(83380400001)(26005)(38070700005)(38100700002)(5660300002)(122000001)(55016002)(45080400002);
 DIR:OUT; SFP:1101; 
x-ms-exchange-antispam-messagedata-chunkcount: 1
x-ms-exchange-antispam-messagedata-0: =?us-ascii?Q?0JEyKUfL7Buxk1KyiFhoI0DWIsxKmR2nME75aQen89/VD1vqFgz4Si0t3DvT?=
 =?us-ascii?Q?Kbqah/mjRvhk+MYcLIJbUMug1cmW1CC8esDpuk/kgUjcaaxOhLSHJKhnDIX8?=
 =?us-ascii?Q?SMB7cZo5YFf4hc7HmD1n/0v1sBQCwW1lMrdh1Tk1CparuDnGTiPk8J7Dk4PN?=
 =?us-ascii?Q?Ok2iOEsc+ZZWfCMCpCBlWqLIVnN4AAy2nVo6ilTuUkTL7YiZxJua4PSDPdAJ?=
 =?us-ascii?Q?MuusPKhJXIHEIt834la547KxdEdMJVWzb/KjwGaPKmJfbUNy8yyG8QC50/IA?=
 =?us-ascii?Q?/1wnBlHO6yXdukoWRqW0nwOso6mM0sH1y+JGO77BSg1UUotAsr3PeorgLFmW?=
 =?us-ascii?Q?293ZzE5S7aVW3fGd2JguBgcCOxKTZ6dYJfreTHoyBGNOT0Gx7KoPI/84nAUI?=
 =?us-ascii?Q?FGPe1b1gZ4FSXumlWLwgNu9DoQ+MENpqhRk1+Ql1rl35xNVKJNZzD13Tm3Hz?=
 =?us-ascii?Q?C2qyecuCIR0K4bh7c1+RFjbsy8lI0BNIFql0IpuBECVKfhvkjjbZlso0uOcO?=
 =?us-ascii?Q?06RdemZhTs5/k8os45pn5BLkqaaCog/kzYIY7J2gG8+rkzfNnFCLusT8Oyoo?=
 =?us-ascii?Q?yHdYlN8i0ZSbkj6mv5+SbH4DPc7YAGo344YB3z1xk+OkUMbgB5OXEgrM798e?=
 =?us-ascii?Q?l6IoHkuL7jYN4G4IaI6QAMwQq1ZWV9uM5jR2kZOiplD/DUZ/yYTknIcscUQZ?=
 =?us-ascii?Q?lRf4rcOArK2yA6yEqIgyAeisz85Ezuy19cPQCBNLbn0gCFOkPXC7AU3BLCui?=
 =?us-ascii?Q?Iu+LNi6XJpa2TJkq3vpS6bBxa4IWKNN9v6XqkzVq56oLLgnnDNpH1QzE/BSH?=
 =?us-ascii?Q?C2PhXQKMoPiipFg9vopOI/IiZtlu7HIMLwM3Rf6v5Jqn7sSIfB1GySbX78Qo?=
 =?us-ascii?Q?JL0XLW1BFDIxEoEEqOCzB9l+NDaMdrKfpmLO2ijaKo1cF8aOigmBIfhTZTWJ?=
 =?us-ascii?Q?ut/KDDmdAbvYoiFZNoHOQjcxmcr9aSFtI/ZX2wWA9WfDF8N/mnf0xJa9IkGT?=
 =?us-ascii?Q?BjvopIlkP2CCZ4JZINdVL79oQfxcjFmKQ1TDrhI+Bj3PrIM9TA/uHB3viebg?=
 =?us-ascii?Q?yhCl8QoERhLl1jQpmOldnGiU0lT5z0b9wYni9b3Q7AeyDxqt3ZpFUp3T79EF?=
 =?us-ascii?Q?q8xpMHwBJAjXtl8QqegrgGKcUR5tmu3fDx5NHqNdpxSljQac5N7VEKbUxgob?=
 =?us-ascii?Q?NtWc1QEm90aochEQL7z18bIT1YPyvd9oNMCQ/LNFgvHc1goJV8ALG98U+J5U?=
 =?us-ascii?Q?alMvmQ14BQgU3XkMtVbIYppijWkgB03dxgkJ+lTF2I7ACq3R2reGj7MHNb44?=
 =?us-ascii?Q?kSsr79KzAf2kUBDOQL6jb3ryPf84n+Lr+F08xY8Ln6nHv49DJ0oGMLUx/15A?=
 =?us-ascii?Q?YgnQytWlQlWZAEP4Of2WW6Ez37Ljri4abX7xtpIj2z1lk+mPNFzz5LHwEFUK?=
 =?us-ascii?Q?u8B1wB7EbNVB7BvVaek9cslzDsol+j+/JycA0b8JopHXy/qZ9qvtzV1ckgTO?=
 =?us-ascii?Q?DguIf0i8CBYzmR4zq25/BDtCX11fcLNufMTd5oYQcCaaSWPNY3zuzlLQZr8S?=
 =?us-ascii?Q?yD5C6N4ZcSC8HN6IkG74NTlkuyDvWz1EiX21K4+bRxpDAnKOZrruxDypUW1+?=
 =?us-ascii?Q?iQ=3D=3D?=
Content-Type: text/plain; charset="us-ascii"
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-OriginatorOrg: coderedcorp.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-AuthSource: CH2PR12MB4231.namprd12.prod.outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 52a00520-19ae-489e-b947-08d998a09719
X-MS-Exchange-CrossTenant-originalarrivaltime: 26 Oct 2021 16:49:34.6263 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Hosted
X-MS-Exchange-CrossTenant-id: 9c94adb1-2ce8-484f-be82-c9b5127d4cb1
X-MS-Exchange-CrossTenant-mailboxtype: HOSTED
X-MS-Exchange-CrossTenant-userprincipalname: hk3hw3GXrcyL1JF4+twOadVbUdGufr/JoppG3A+0Ebktb4ju+tDo8Wl6AMTrp10Vpk10fTdncX+YzgjKC29m1w==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: CH2PR12MB4277
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51404
X-Mailman-Approved-At: Tue, 26 Oct 2021 13:05:15 -0400
Cc: "51404 <at> debbugs.gnu.org" <51404 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> > +#define DARK_MODE_APP_NAME L"DarkMode_Explorer"

> Can we make this exposed to Lisp, rather than hard-coded?  Hard-coding a =
specific application for a theme sounds un-Emacsy.  People could want to ex=
periment with other apps.

Given that this is not so much a preference, as an undocumented magic strin=
g in Win32, I think anyone who wants to play with this is going to require =
knowledge of C and gdb to experiment, to risk causing erratic and unknown b=
ehavior. So I would be inclined to keep it in C.


> > +#ifndef DWMWA_USE_IMMERSIVE_DARK_MODE #define=20
> > +DWMWA_USE_IMMERSIVE_DARK_MODE 20

> Why not use 19 and 20, depending on the Windows build number, and thus ex=
pand the applicability of the feature?

I can add support for 19, but do not have the ability to test it on those s=
pecific Win10 builds to confirm if it actually works as expected. If someon=
e is able to test on a version of Windows 10 older than 2004, then I will i=
nclude. Erring on the side of stability for now.


> +/* Applies the Windows system theme (light or dark) to a window=20
> +handle. */ static void w32_applytheme(HWND hwnd) {
> +  if (w32_darkmode) {
> +    /* Set window theme to that of a built-in Windows app (Explorer)
> +       because it has dark scroll bars and other UI elements. */

> Likewise here: it should be able to control this behavior by a user optio=
n.  We cannot assume that every Emacs user will automatically want to follo=
w the system theme.

I agree this would be a "nice to have", but the current functionality is in=
-line with behavior on other systems (GTK, macOS, etc. i.e. the application=
 has no say in window decorations which are controlled by the window manage=
r). If we did add an elisp setting it should default to the registry value =
at runtime. I also have no idea how to create an elisp setting and read it =
in C. Examples or contributions to this patch would be helpful.


> > +    /* Set the titlebar to system dark mode. */
> > +    if (DwmSetWindowAttribute_fn) {
> > +      DwmSetWindowAttribute_fn
> > +	(hwnd,
> > +	 DWMWA_USE_IMMERSIVE_DARK_MODE,
> > +	 &w32_darkmode,
> > +	 sizeof(w32_darkmode));
> > +    }

> Does it make sense to call DwmSetWindowAttribute if we couldn't call SetW=
indowTheme?  I know that such a situation shouldn't normally happen, but wh=
at if it does?  If we need both calls, the second call should be conditione=
d by SetWindowTheme_fn as well.

There is no harm in calling one without the other. SetWindowTheme sets thin=
gs like scrollbars. DwmSetWindowAttribute specifically sets the titlebar. M=
y original proof-of-concept only had DwmSetWindowAttribute and worked fine.

I will make the other requested changes, i.e. registry helper, style guide,=
 and NEWS; and submit an updated patch.


Vince Salvino

-----Original Message-----
From: Eli Zaretskii <eliz@HIDDEN>=20
Sent: Tuesday, October 26, 2021 10:02 AM
To: Vince Salvino <salvino@HIDDEN>
Cc: 51404 <at> debbugs.gnu.org
Subject: Re: bug#51404: Support system dark mode on Windows 10

> From: Vince Salvino <salvino@HIDDEN>
> Date: Tue, 26 Oct 2021 04:46:27 +0000
>=20
> Attached is the patch. Additional info available here:=20
> https://github.com/vsalvino/emacs

Thanks.  I have some comments and questions below, but in any case these ch=
anges are large enough to require copyright assignment from you.  If you'd =
be willing to start the legal paperwork at this time, I will send you the f=
orm to fill with the appropriate instructions.

>  LPBYTE
>  w32_get_resource (const char *key, LPDWORD lpdwtype)
> +{
> +  return w32_query_registry(REG_ROOT, key, lpdwtype); }
> +
> +/* Enables reading any key/name from the Windows Registry */ LPBYTE=20
> +w32_query_registry (const char *root, const char *key, LPDWORD=20
> +lpdwtype)

I'd prefer that you simply add an extra argument to the existing w32_get_re=
source, and adjust its single caller to pass REG_ROOT there.

> +/*
> +  Internal/undocumented constants for Windows Dark mode.
> +  See: https://github.com/microsoft/WindowsAppSDK/issues/41
> +*/

Please follow our style for comments, both single-line and multi-line.

> +#define DARK_MODE_APP_NAME L"DarkMode_Explorer"

Can we make this exposed to Lisp, rather than hard-coded?  Hard-coding a sp=
ecific application for a theme sounds un-Emacsy.  People could want to expe=
riment with other apps.

> +#ifndef DWMWA_USE_IMMERSIVE_DARK_MODE #define=20
> +DWMWA_USE_IMMERSIVE_DARK_MODE 20

Why not use 19 and 20, depending on the Windows build number, and thus expa=
nd the applicability of the feature?

> +/* Applies the Windows system theme (light or dark) to a window=20
> +handle. */ static void w32_applytheme(HWND hwnd) {
> +  if (w32_darkmode) {
> +    /* Set window theme to that of a built-in Windows app (Explorer)
> +       because it has dark scroll bars and other UI elements. */

Likewise here: it should be able to control this behavior by a user option.=
  We cannot assume that every Emacs user will automatically want to follow =
the system theme.

> +    if(SetWindowTheme_fn) {
> +      SetWindowTheme_fn(hwnd, DARK_MODE_APP_NAME, NULL);
> +    }

Please follow our style of using braces in C code.

> +    /* Set the titlebar to system dark mode. */
> +    if (DwmSetWindowAttribute_fn) {
> +      DwmSetWindowAttribute_fn
> +	(hwnd,
> +	 DWMWA_USE_IMMERSIVE_DARK_MODE,
> +	 &w32_darkmode,
> +	 sizeof(w32_darkmode));
> +    }

Does it make sense to call DwmSetWindowAttribute if we couldn't call SetWin=
dowTheme?  I know that such a situation shouldn't normally happen, but what=
 if it does?  If we need both calls, the second call should be conditioned =
by SetWindowTheme_fn as well.

Last, but not least: this feature should be called out in NEWS and preferab=
ly also described in the "MS-Windows" Appendix in the Emacs manual.

Thanks again for working on this.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 26 Oct 2021 16:18:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 26 12:18:26 2021
Received: from localhost ([127.0.0.1]:47406 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mfP9d-0004R2-UN
	for submit <at> debbugs.gnu.org; Tue, 26 Oct 2021 12:18:26 -0400
Received: from eggs.gnu.org ([209.51.188.92]:34626)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mfP9Y-0004Qi-Fp
 for 51404 <at> debbugs.gnu.org; Tue, 26 Oct 2021 12:18:24 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:33506)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mfP9T-0002Hz-0n; Tue, 26 Oct 2021 12:18:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=33ai7VJA2YK6Q7HiEqABTfUwQGbqy5zS1zTV7hBuDkc=; b=pQohMo+as0lO
 avbE+YywQRQSqcR995+KAVEPz0eNkBBVfzRFe2geiUHFzrjHWMLGl3czTf7oxpr5XrWJv6urh5UU5
 ojTkePPD1fo9mcwyG//r6perHyWcu7wyRTQhSqa82fF967lPVO3R/wJBaWcfxqxdtP6sU08zzmqNc
 XiIltQY2EELauOkulDFOfrxYzlieiK/8VKdDkXu+KGXVf3YvLvTRbsNzb6Giv1swi8/dRVHLXnOBf
 qFTYWTDHQ2wDowchlxBSTWB9/nwMnQVhYOdw6viuEVmb1xOvzCKS7AVsIJk7RlfyO2SsZFA+f0s2K
 OJsWxxtn0jMgo2eCJlnAyA==;
Received: from [87.69.77.57] (port=1511 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mfP9S-00043b-EP; Tue, 26 Oct 2021 12:18:14 -0400
Date: Tue, 26 Oct 2021 19:18:11 +0300
Message-Id: <83h7d3yd30.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: salvino@HIDDEN
In-Reply-To: <834k93zxyo.fsf@HIDDEN> (message from Eli Zaretskii on Tue, 26
 Oct 2021 17:01:51 +0300)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 <834k93zxyo.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: 51404 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Tue, 26 Oct 2021 17:01:51 +0300
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 51404 <at> debbugs.gnu.org
> 
> Thanks.  I have some comments and questions below, but in any case
> these changes are large enough to require copyright assignment from
> you.  If you'd be willing to start the legal paperwork at this time, I
> will send you the form to fill with the appropriate instructions.

Actually, I now see that you already started the legal paperwork
rolling, so we are okay in that department.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at 51404 <at> debbugs.gnu.org:


Received: (at 51404) by debbugs.gnu.org; 26 Oct 2021 14:02:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 26 10:02:05 2021
Received: from localhost ([127.0.0.1]:47264 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mfN1h-0000YF-Ck
	for submit <at> debbugs.gnu.org; Tue, 26 Oct 2021 10:02:05 -0400
Received: from eggs.gnu.org ([209.51.188.92]:46498)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mfN1e-0000Xe-Qv
 for 51404 <at> debbugs.gnu.org; Tue, 26 Oct 2021 10:02:04 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56458)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mfN1Z-00041d-B0; Tue, 26 Oct 2021 10:01:57 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=kVF6zMs7kfohqr+6iaEj4wskRsw3OT99mgjgDtoQXwU=; b=fXwQbD4MeNc+
 bHN32qHduzNpt7HrXHr78Llg+LYKjb684kBqLmV2LnE+TFtScz8qfLLGvYLx064NNfEPcP/WPkmHl
 LifHIdAjzXdZFYKgYim6GbwcX+c3zkVaANwClrHuB5Qh1sfwjE8xb1H5Mj39wdizL7CPOaK36fReS
 bsvYBzvt27aRugRMFN8UDt1yVPhzrxOLJEpFti9dWeJpQ2tRrRj/TzQvye6oYaTIdydonJJaQvoNj
 nR/JX4CGNu4HbFwOcdA0eaEx7hlpxtEkofI18kL/FcOkfzsspOMt2EyHLuqG7S3qhWe6qILUIHAkG
 JCu+1M5h+ofJODyP88aI7A==;
Received: from [87.69.77.57] (port=4088 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mfN1Y-0002qc-Ch; Tue, 26 Oct 2021 10:01:57 -0400
Date: Tue, 26 Oct 2021 17:01:51 +0300
Message-Id: <834k93zxyo.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Vince Salvino <salvino@HIDDEN>
In-Reply-To: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
 (message from Vince Salvino on Tue, 26 Oct 2021 04:46:27 +0000)
Subject: Re: bug#51404: Support system dark mode on Windows 10
References: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51404
Cc: 51404 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Vince Salvino <salvino@HIDDEN>
> Date: Tue, 26 Oct 2021 04:46:27 +0000
> 
> Attached is the patch. Additional info available here: https://github.com/vsalvino/emacs

Thanks.  I have some comments and questions below, but in any case
these changes are large enough to require copyright assignment from
you.  If you'd be willing to start the legal paperwork at this time, I
will send you the form to fill with the appropriate instructions.

>  LPBYTE
>  w32_get_resource (const char *key, LPDWORD lpdwtype)
> +{
> +  return w32_query_registry(REG_ROOT, key, lpdwtype);
> +}
> +
> +/* Enables reading any key/name from the Windows Registry */
> +LPBYTE
> +w32_query_registry (const char *root, const char *key, LPDWORD lpdwtype)

I'd prefer that you simply add an extra argument to the existing
w32_get_resource, and adjust its single caller to pass REG_ROOT there.

> +/*
> +  Internal/undocumented constants for Windows Dark mode.
> +  See: https://github.com/microsoft/WindowsAppSDK/issues/41
> +*/

Please follow our style for comments, both single-line and multi-line.

> +#define DARK_MODE_APP_NAME L"DarkMode_Explorer"

Can we make this exposed to Lisp, rather than hard-coded?  Hard-coding
a specific application for a theme sounds un-Emacsy.  People could
want to experiment with other apps.

> +#ifndef DWMWA_USE_IMMERSIVE_DARK_MODE
> +#define DWMWA_USE_IMMERSIVE_DARK_MODE 20

Why not use 19 and 20, depending on the Windows build number, and thus
expand the applicability of the feature?

> +/* Applies the Windows system theme (light or dark) to a window handle. */
> +static void
> +w32_applytheme(HWND hwnd)
> +{
> +  if (w32_darkmode) {
> +    /* Set window theme to that of a built-in Windows app (Explorer)
> +       because it has dark scroll bars and other UI elements. */

Likewise here: it should be able to control this behavior by a user
option.  We cannot assume that every Emacs user will automatically
want to follow the system theme.

> +    if(SetWindowTheme_fn) {
> +      SetWindowTheme_fn(hwnd, DARK_MODE_APP_NAME, NULL);
> +    }

Please follow our style of using braces in C code.

> +    /* Set the titlebar to system dark mode. */
> +    if (DwmSetWindowAttribute_fn) {
> +      DwmSetWindowAttribute_fn
> +	(hwnd,
> +	 DWMWA_USE_IMMERSIVE_DARK_MODE,
> +	 &w32_darkmode,
> +	 sizeof(w32_darkmode));
> +    }

Does it make sense to call DwmSetWindowAttribute if we couldn't call
SetWindowTheme?  I know that such a situation shouldn't normally
happen, but what if it does?  If we need both calls, the second call
should be conditioned by SetWindowTheme_fn as well.

Last, but not least: this feature should be called out in NEWS and
preferably also described in the "MS-Windows" Appendix in the Emacs
manual.

Thanks again for working on this.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 26 Oct 2021 06:57:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 26 02:57:39 2021
Received: from localhost ([127.0.0.1]:44913 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mfGOw-0000yw-Hb
	for submit <at> debbugs.gnu.org; Tue, 26 Oct 2021 02:57:38 -0400
Received: from lists.gnu.org ([209.51.188.17]:50954)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <salvino@HIDDEN>) id 1mfEM6-0005vt-Ds
 for submit <at> debbugs.gnu.org; Tue, 26 Oct 2021 00:46:34 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:35682)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <salvino@HIDDEN>)
 id 1mfEM6-0007tf-5u
 for bug-gnu-emacs@HIDDEN; Tue, 26 Oct 2021 00:46:34 -0400
Received: from mail-bn8nam12on2069.outbound.protection.outlook.com
 ([40.107.237.69]:23232 helo=NAM12-BN8-obe.outbound.protection.outlook.com)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <salvino@HIDDEN>)
 id 1mfEM3-0003bl-Hf
 for bug-gnu-emacs@HIDDEN; Tue, 26 Oct 2021 00:46:33 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=HDbJTMfPl5tG/N4kZMCGXrYT3spcoIW3wnoKtUpshd7/F7Teh7uZy70yM5++QR+CnZBtgoKFOTQ7zsfcY2sOHhZbHPAGBBYbVR3UBy1Ut52ICP2OLbsAzmJD/pVmBW85War3nZE8H+KfhS/JKqJspiW4vjfjSuOc00Z/PgRoKla9+LOrzokbEYNJoITYZ0orUSvYQ+cDJ3UqbiC83Eil3AGi7G0dslMIo66+a1JZdMd7RVFjUD57KzQfH09Cm2u1/uuoXPBiARnuxZn7SF6gmHjv4SRVuR1GiW+bIOBK28Am6o31gvm16PzKfodIt4bZj523Fh3ALTaUqAnZ1RQzzA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=f2UR7TWeErHJyZSi294XVKOe2NqnEUv+H9EYYOysijU=;
 b=hM+7bAYFkBk5FRXiYc7JUM5mfnHaakfk46rsNdihDySygcd64iBjDZrNlr/kmJqmOQtjoGVAVBFcF3cTGtli60q5H0lU//r18nhJ4Clt4apnktWY+SS1yPh5tMy6NgeV8muY0TGw/YXc+NAvWx8vcDc3uNZDiGDfNuQW1kfvsC5bNdu/tMoSOefquyP91ZnD4rmNaN3euNFmWs6iRq65tgQDaYSGmG/ko9ml0sQyz78nrjHmpcMl+XQgKAaseszkLfnRFes+q6HzaDe7PfwJCLNb/WDuZH/0A3VTOWiYoScGjvhcyhN1lHhQxKNAODB2IMFCAoduELeI311wGbV/XQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=coderedcorp.com; dmarc=pass action=none
 header.from=coderedcorp.com; dkim=pass header.d=coderedcorp.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=coderedcorp.com;
 s=selector2;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=f2UR7TWeErHJyZSi294XVKOe2NqnEUv+H9EYYOysijU=;
 b=hMZPLZgv63wt4mr9M2bhtHdBfrCN2jMvAoVKznQGMfo7SCRggAQdXcdezeHlfiYoQ++nVfDJmo5j/P+6cMHzQSkarNUg+EQfimWmxtS66MkFuSolb+RrmOMAO3SsTgLGDAD5ARtOS/Qzd6caA/oydHq7jb/ahDvyNmnWB1HwCLc=
Received: from CH2PR12MB4231.namprd12.prod.outlook.com (2603:10b6:610:7d::24)
 by CH2PR12MB4088.namprd12.prod.outlook.com (2603:10b6:610:a5::8) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4628.18; Tue, 26 Oct
 2021 04:46:28 +0000
Received: from CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b]) by CH2PR12MB4231.namprd12.prod.outlook.com
 ([fe80::55e4:7d22:a6df:970b%6]) with mapi id 15.20.4628.020; Tue, 26 Oct 2021
 04:46:27 +0000
From: Vince Salvino <salvino@HIDDEN>
To: "bug-gnu-emacs@HIDDEN" <bug-gnu-emacs@HIDDEN>
Subject: Support system dark mode on Windows 10
Thread-Topic: Support system dark mode on Windows 10
Thread-Index: AdfKJC1fFkosmLKeRpu5RIGxKoA2eg==
Date: Tue, 26 Oct 2021 04:46:27 +0000
Message-ID: <CH2PR12MB4231758A937F6FB9F33291CFA5849@HIDDEN>
Accept-Language: en-US
Content-Language: en-US
X-MS-Has-Attach: yes
X-MS-TNEF-Correlator: 
authentication-results: gnu.org; dkim=none (message not signed)
 header.d=none;gnu.org; dmarc=none action=none header.from=coderedcorp.com;
x-ms-publictraffictype: Email
x-ms-office365-filtering-correlation-id: 04c44189-8e8b-4133-642e-08d9983b929a
x-ms-traffictypediagnostic: CH2PR12MB4088:
x-microsoft-antispam-prvs: <CH2PR12MB4088CABDFC5BAA5D2C5F4573A5849@HIDDEN>
x-ms-oob-tlc-oobclassifiers: OLM:7219;
x-ms-exchange-senderadcheck: 1
x-ms-exchange-antispam-relay: 0
x-microsoft-antispam: BCL:0;
x-microsoft-antispam-message-info: LA54nUrWLyeU87AmH2xEl8SzO8O2gzCB7S/w1WJ1WiVkm48yXkDpfoFNudFKb4NMxILp77uZYiuhLcb9KWhrMVaBnsBRvHyoc8H/baNWxKhNAVY/NfwkRn3LW981lZT/VQIrz0chXPvwlZ445MaVC0MYVIf5FJnc8kyo77NFNuw2x6QPWJ6I9+2NRHufly1m7j1JS7X3b9i3R/puUZrJHN+VbmEDrSUHN7VCUmI9lO5crL47CtkyzeBRmIEGC5KWxkfEEbaS8o71fAFgYIySj0CX1tfPCxYK9NTQw4rFksolLTdFe+o9/yyIsJPOm5gjyEWBM51rSUQ2newxiI2YDYHhrwCAjtPmqyDCDXe4/WA2tCyCOjZMXCeL+sEhF/Rgs3gD87Jfil2JxJUT8EkTGN6LwUbklVcogHsjXcLnC6pm02Jh1HVHPPUk/oQ2yxc5eJHUy/z+cS75/woRjQhNaWfcUcvWg7h1dGPx+Q4q7oL9eJomUXzd10bmKvlS9SSyFulnpegXY6F48QLuQugRvMHJwflyENZGoZe23YoDoEZj3JxDCyh0Unem9H6fFUiiJiQIxb9hM3/4jNTUT3Y5cLUkKtHIBod+1W/t2yqpbdyeOrCEnAmdINdn3jzqQO+5wflG5rI0hAaEnhNQ9+IO9H7LtLwApQhyVFiP+hPrjBqmJMYVT4C6J+Dr6nzrxe+aL7uavqORwAy69bRRP/KQDl+eglF89I+kYZ3SvHtUwkFH19hM+ZW8sCUTRwgONjOGhMrkqw0NMsN0X9lN57P/CtpUobBq+2+bmBiPlt17b7I=
x-forefront-antispam-report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:CH2PR12MB4231.namprd12.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(39830400003)(136003)(396003)(376002)(346002)(366004)(558084003)(99936003)(508600001)(122000001)(33656002)(38100700002)(4270600006)(8936002)(86362001)(55016002)(8676002)(38070700005)(316002)(66446008)(64756008)(66476007)(66946007)(66556008)(76116006)(2906002)(9686003)(71200400001)(966005)(6506007)(5660300002)(7696005)(186003)(26005)(6916009)(52536014);
 DIR:OUT; SFP:1101; 
x-ms-exchange-antispam-messagedata-chunkcount: 1
x-ms-exchange-antispam-messagedata-0: =?us-ascii?Q?n7T/01rgr5Gow8KM5pfUUXtb2AfK9hLo6Ycu71FYIpvaBN19uKLz+yz5r8PO?=
 =?us-ascii?Q?xPxnSq3beE8fgcF0W+mynW9qBMoYFqiKpdJTkL6ToqxCY3YlU3YSVZWCILRP?=
 =?us-ascii?Q?bHb9IlHjsuA83/eR4Ts267RhmjoVg5SvEeY6BRzqSV+aruGWxLBh1u2x2CaZ?=
 =?us-ascii?Q?NI7k3NMJTwhiXdEwfycs+fa0GMK8tA+UmfGyt07MwYxNvJOdip7ZasJxSi3R?=
 =?us-ascii?Q?2rhI9vwKzqbYRGlf0YeNpxrZNCx5UzOfM6QIbKjHHg+Gk+lTVcoEGRTe2DTU?=
 =?us-ascii?Q?UHVW4J/h6KNdN8OfAUOe0l6yuoYcKApNOgkGTXCD6dqSuU8NijO/uLQFNkA2?=
 =?us-ascii?Q?UgbMZUyeaWiIGUW4dVfGfe9BQLYywlPDp8ACHWKmKEwhYHrgiRnQDEMQwJcD?=
 =?us-ascii?Q?FL+CCPVzIyHMuhC1NsWpynmR9NGsEGNwVg0KfCOmtuezyQREZJT9TouSw3jR?=
 =?us-ascii?Q?bEJHycpMNEqhguD1gtr2bFr3ZdAZ5gGg4rknJjiyC6tg08hI0m6lFTFLMajn?=
 =?us-ascii?Q?G00zh5nsBRoN9G7l+DQctw3HHw+D+fdoV0/eDrUBi4tuhvjOB6Wp/k7VMAmo?=
 =?us-ascii?Q?F98g7Fcc7UJUwtAJMTEOgHfaUj1Noa33q3qxZR+v6uaMcXXGoEMxWG5ZTWTJ?=
 =?us-ascii?Q?4VmBlGbVNQf1cvSUwiJphG7T3fnEDe3C4eT+0bAIv4LRvhy8sFKqMU/2NwXH?=
 =?us-ascii?Q?sgDGF3MZjieORpBOUEd96JTltLRCIj1eBixeagCsgXz04tu2URVWFF6Bm154?=
 =?us-ascii?Q?CrYJLKSIzNgd0s1HzlFgLeURwNvTXjJuiIFWrRFOAnWmsmYegq3+JzLSRt4J?=
 =?us-ascii?Q?7EHi47H1sE6ZlGZ9h6CwQkwOwI/Y/XLVezAoVNt9+GGc9qFV9bGu8ADwPKZQ?=
 =?us-ascii?Q?vNyitDuBsO6G7eLwnwA4TxzKuyCnyfOte8ASHHl4t1Fg3EkKHqu/RR5VFfLe?=
 =?us-ascii?Q?BVxS1V2E/tvEKK84R8SMss/ro8AAEYCnJtXmlTzGuABWMPAWuBbEjcTNfnP7?=
 =?us-ascii?Q?x8gzleF8oyfzbDrNlgUkcY0cW384RopyP/wUho+E2HYrJmrFXn0zHX96mBxC?=
 =?us-ascii?Q?PFWH3IUb/KY+EBuoNpUa3oHtWb/3kg+DW3panAEgkHReLqgwUADnKVN5AoOR?=
 =?us-ascii?Q?+i7fl5g1xCBiMA3yEahYFfwXmoI6MksT9krvGGmsOMXLGbHeoQUMXMWgIG5c?=
 =?us-ascii?Q?C359xcESXKKySWZz9aeQlP33DfD+tyZplzjSuF/VcOBIwP7mVNdlmOK4DNFA?=
 =?us-ascii?Q?jkcaXXM4vFp/S0gPVF8PY5hJC/Dl/IyuMrduwkPKgY3pUTnwQrxqHaNe8J43?=
 =?us-ascii?Q?KPh8N48K1QWtfFmm4Bqgs5vniDeT/HumBMMUrjZCQ5JE17ghAYzSl6+VMM7S?=
 =?us-ascii?Q?YreevEi/w1+Y87QKyfPy9wX7yZ6zQTxGAoac44un1IIJ+AN5SlRtCDHMI/BK?=
 =?us-ascii?Q?mkJnkv8UarHzs5HCEN5ULtT3JkrFGVAiPewxcZDBAFuvDXnL0KHWbiRQF9Xs?=
 =?us-ascii?Q?6rKzh9ddnJmU2YtWalM2FOzQD9qN9RPbdeD2G+IZh8+OblyhL1eBFylr7TBY?=
 =?us-ascii?Q?4oiuq4JdkJgX9Mt0UGvwb9o31qHWgAL4ntB1QFyShbNuEI6xymABCYahd1dV?=
 =?us-ascii?Q?YIr1W7YooB9hntfdXHXvcJE=3D?=
Content-Type: multipart/mixed;
 boundary="_002_CH2PR12MB4231758A937F6FB9F33291CFA5849CH2PR12MB4231namp_"
MIME-Version: 1.0
X-OriginatorOrg: coderedcorp.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-AuthSource: CH2PR12MB4231.namprd12.prod.outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 04c44189-8e8b-4133-642e-08d9983b929a
X-MS-Exchange-CrossTenant-originalarrivaltime: 26 Oct 2021 04:46:27.8107 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Hosted
X-MS-Exchange-CrossTenant-id: 9c94adb1-2ce8-484f-be82-c9b5127d4cb1
X-MS-Exchange-CrossTenant-mailboxtype: HOSTED
X-MS-Exchange-CrossTenant-userprincipalname: BfXt4bWh/3jLtYIdzBwFkPAtCAZcYIPGmD7FQYRtTf/ZtXch0J2MXQ4VUCJZkjUtjEMHxmP9vee9XC25aYG0BQ==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: CH2PR12MB4088
Received-SPF: pass client-ip=40.107.237.69;
 envelope-from=salvino@HIDDEN;
 helo=NAM12-BN8-obe.outbound.protection.outlook.com
X-Spam_score_int: -1
X-Spam_score: -0.2
X-Spam_bar: /
X-Spam_report: (-0.2 / 5.0 requ) BAYES_20=-0.001, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_NONE=-0.0001, RCVD_IN_MSPIKE_H2=-0.001, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Tue, 26 Oct 2021 02:57:37 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

--_002_CH2PR12MB4231758A937F6FB9F33291CFA5849CH2PR12MB4231namp_
Content-Type: text/plain; charset="us-ascii"
Content-Transfer-Encoding: quoted-printable

Attached is the patch. Additional info available here: https://github.com/v=
salvino/emacs


Vince Salvino


--_002_CH2PR12MB4231758A937F6FB9F33291CFA5849CH2PR12MB4231namp_
Content-Type: application/octet-stream;
	name="0001-Support-system-dark-mode-on-Windows-10-version-2004-.patch"
Content-Description:  0001-Support-system-dark-mode-on-Windows-10-version-2004-.patch
Content-Disposition: attachment;
	filename="0001-Support-system-dark-mode-on-Windows-10-version-2004-.patch";
	size=7491; creation-date="Tue, 26 Oct 2021 04:37:55 GMT";
	modification-date="Tue, 26 Oct 2021 04:37:55 GMT"
Content-Transfer-Encoding: base64
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--_002_CH2PR12MB4231758A937F6FB9F33291CFA5849CH2PR12MB4231namp_--




Acknowledgement sent to Vince Salvino <salvino@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#51404; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 12 Nov 2021 06:30:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.